#include"graphics.h"
#include"conio.h"
#include"stdio.h"
#include"iostream.h"
#include"stdlib.h"
#include"string.h"
#include"dos.h"
#define TRUE 1
#define FALSE 0
int Play_level(int,float,int);
void intro_screen();
class bitmaps
{
	public:
	void *sp_craft;
	void *bullet;
	void *asteroid[3];
	void initcraft();
	void initaustroid();
	void initbullet();
	~bitmaps()
	{
		free(sp_craft);
		free(bullet);
		free(asteroid[0]);
		free(asteroid[1]);
		free(asteroid[2]);
	}
};

void bitmaps::initbullet()
{
	setcolor(RED);
	line(100,300,100,308);//center
	line(99,301,99,309);//left1
	line(98,302,98,310);//left2
	line(101,301,101,309);//right1
	line(102,302,102,310);//right2
	setcolor(WHITE);
	bullet=malloc(imagesize(98,298,102,312));
	getimage(98,298,102,312,bullet);
}

void bitmaps::initaustroid()
{
	//approx radius of the asteroid is 9pixels
	setcolor(LIGHTGRAY);
	setfillstyle(SOLID_FILL,DARKGRAY);
	//asteroid 1
	//	1	 2	 3	 4	 5	 6 	 7	 8	 9	 10	 11	 12
	int p1[]={200,200,203,197,206,194,209,194,211,198,214,200,214,206,207,210,204,206,202,207,198,205,200,202};
	fillpoly(12,p1);
	asteroid[0]=malloc(imagesize(197,192,215,210));
	getimage(197,192,215,210,asteroid[0]);
	//asteroid 2
	//	  1       2	  3	  4	  5	  6 	  7 	  8	  9	  10	  11	  12
	int p2[]={202,221,201,218,207,213,210,215,210,217,215,222,215,225,206,230,203,227,200,225,199,224,201,220};
	fillpoly(12,p2);
	asteroid[1]=malloc(imagesize(197,212,215,230));
	getimage(197,212,215,230,asteroid[1]);
	//asteroid 3
	//	  1       2	  3	  4	  5	  6 	  7 	  8	  9	  10	  11	  12
	int p3[]={201,242,202,239,206,234,211,236,213,238,216,243,216,244,209,250,204,247,200,245,201,244,201,240};
	fillpoly(12,p3);
	asteroid[2]=malloc(imagesize(198,232,216,250));
	getimage(198,232,216,250,asteroid[2]);
}

void bitmaps::initcraft()
{
	setcolor(LIGHTGRAY);
	line(96,106,103,96);//top triangle
	line(103,96,110,106);
	line(96,106,110,106);
	setfillstyle(SOLID_FILL,RED);
	floodfill(103,100,LIGHTGRAY);
	line(96,115,110,115);//connectors
	line(96,118,110,118);
	setcolor(WHITE);
	setfillstyle(SOLID_FILL,DARKGRAY);
	bar(88,100,92,120);
	bar(113,100,117,120);
	setfillstyle(SOLID_FILL,LIGHTGRAY);
	bar(100,106,105,125);//the body
	bar(101,125,104,130);//tail
	arc(101,128,105,180,18); //left engine
	line(96,111,96,128);
	line(96,128,84,128);
	arc(104,128,360,75,18); //right engine
	line(109,111,109,128);
	line(110,128,122,128);
	setfillstyle(SOLID_FILL,8);
	floodfill(112,120,WHITE);
	floodfill(90,120,WHITE);
	setfillstyle(SOLID_FILL,RED);
	bar(114,129,119,133);
	bar(86,129,91,133);
	sp_craft=malloc(imagesize(82,95,123,134));
	getimage(82,95,123,134,sp_craft);
}

bitmaps bmp;
class space_craft
{
	public:
	int x,xmove;

	void shownext()
	{
		putimage(x,400,bmp.sp_craft,COPY_PUT);
		if(xmove==-1&&x>1||xmove==1&&x<460-42)//-42 is the size of the space craft
		{
			x=x+xmove;
		}
	}

	space_craft()
	{
		xmove=0;
		x=230;
	}

	void reset()
	{
		xmove=0;
		x=230;
	}

    int gothit(int sx,int ex,int y)
	{
		if( ( (sx>x&&y>400&&sx<x+41) || (ex>x&&y>400&&ex<x+41) ) &&y<440)
			return 1;
		else
			return 0;
	}
};


class asteroids
{
	void *ast_bmp;
	public:
	float x,y;
	int present_flag;
	int value;
	void shownext()
	{
		if(present_flag)
		{
			if(y<462)
			{
				putimage(x,y,ast_bmp,COPY_PUT);
				y++;
			}
		else
			{
				putimage(x,y-1,ast_bmp,XOR_PUT);
				x=rand()%430;
				y=1;
			}
		}
	}

	void initialize(int xpos,int ypos,int val)
	{
		x=xpos;
		y=ypos;
		present_flag=1;
		value=val;
		ast_bmp=bmp.asteroid[value];
	}

	void replace()
	{
		x=rand()%430;
		y=rand()%350;
	}

	int gothit(int xpos,int ypos)
	{
		xpos+=2;
		ypos+=2;
		if(xpos>=x &&xpos<=x+18 && ypos>=y && ypos<=y+16&&present_flag)
		{
			putimage(x,y-1,ast_bmp,XOR_PUT);
			sound(6000);
			delay(5);
			nosound();
			present_flag=0;
			return 1;
		}
		else
			return 0;
	}
};

class bullets
{
	public:
	int x,y;
	int present_flag;
	void start(int xpos)
	{
		x=xpos;
		y=390;
		present_flag=1;
	}
	void shownext()
	{
		if(present_flag)
		{
		       if(y>0)
			{
				putimage(x,y,bmp.bullet,COPY_PUT);
				y--;
			}
			else
			{
				present_flag=0;
				putimage(x,y+1,bmp.bullet,XOR_PUT);
			}
		}
	}

	void destroy()
	{
		present_flag=0;
		setfillstyle(SOLID_FILL,BLACK);//erase the bullet
		bar(x,y,x+6,y+20);
	}

	void reset()
	{
		present_flag=1;
	}
};

class stars
{
	float x,y;
	int color;
	public:
	void shownext()
	{
		putpixel(x,y,BLACK);
		y+=0.5;
		if(y<480)
			putpixel(x,y,color);
		else
			y=0;
	}
	void initialize(int xpos,int ypos,int clr)
	{
		x=xpos;
		y=ypos;
		color=clr;
	}
};

int score,life;
int main()
{
	int gd=DETECT,gm;
	char str[30];
	initgraph(&gd,&gm,"");
	setpalette(14,0x31);
	bmp.initcraft();
	bmp.initaustroid();
	bmp.initbullet();
	randomize();
	intro_screen();//Display the introduction screen
	life=4;
	score=0;
	int Level1_completed=FALSE;
	int Level2_completed=FALSE;
	int Level3_completed=FALSE;
	Level1_completed=Play_level(1,100,3);
	if(Level1_completed)
		{
		cleardevice();
		outtextxy(150,200,"Congrats! You finished Level 1");
		sprintf(str,"Your score:%d",score);
		outtextxy(230,250,str);
		delay(2000);
		getch();
		Level2_completed=Play_level(2,100,2);
		}
	if(Level2_completed)
		{
		cleardevice();
		outtextxy(150,200,"Congrats! You finished Level 2");
		sprintf(str,"Your score:%d",score);
		outtextxy(230,250,str);
		delay(2000);
		getch();
		Level3_completed=Play_level(3,100,1);
		}
	if(Level3_completed)
		{
		cleardevice();
		outtextxy(150,200,"Congrats! You finished The game");
		sprintf(str,"Your score:%d",score);
		outtextxy(230,250,str);
		delay(2000);
		getch();
		}
	else
		{
		cleardevice();
		outtextxy(250,200,"Game Over!");
		sprintf(str,"Your score:%d",score);
		outtextxy(230,250,str);
		delay(2000);
		}
	getch();
	closegraph();
	return 0;
}//here ends the main module

int Play_level(int level,float fuel,int speed)
{
	space_craft s_craft;
	bullets bullet[50];
	stars star[60];
	asteroids asteroid[5];
	int i=0,j,total_bullets,total_hits;
	char str[30];
	char key=0;
	total_bullets=total_hits=0;
	cleardevice();
	setfillstyle(SOLID_FILL,DARKGRAY);
	bar(460,0,639,479);
	setcolor(WHITE);
	settextstyle(8,0,2);
	sprintf(str,"Level:%d",level);
	outtextxy(500,100,str);
	sprintf(str,"Score: %d",score);
	outtextxy(500,200,str);
	sprintf(str,"Lifes: %d",life);
	outtextxy(500,250,str);
	outtextxy(470,440,"'Esc' To Quit");
	outtextxy(510,400,"Fuel");
	setfillstyle(SOLID_FILL,RED);//display currently remaining fuel
	bar(490,430,490+fuel,435);
	for(i=0;i<60;i++)
		star[i].initialize(rand()%460,rand()%480,rand()%16);
	for(i=0;i<5;i++)
		asteroid[i].initialize(rand()%430,rand()%350,rand()%3);
	s_craft.shownext();

	while(key!=79&&key!=27&&fuel>0&&life>0)//loop until endkey or Escape key is not pressed
	{
		while(!kbhit())
		{
			for(i=0;i<5;i++)
			{
			    asteroid[i].shownext();
			    if(s_craft.gothit(asteroid[i].x,asteroid[i].x+9,asteroid[i].y+9))
			    {
				setcolor(WHITE);
				settextstyle(8,0,1);
				outtextxy(470,300,"Oh Boy, You");
				outtextxy(470,320,"Lost your Life!");
				for(i=10;i<10;i++)
				{
					sound(i*10);
					delay(i);
				}
				nosound();
				getch();
				life--;
				if(life==0)// If No life is remaining
				return FALSE;//Return False to indicate level not completed
				s_craft.reset();
				for(i=0;i<5;i++)
					asteroid[i].replace();//replace the asteroids
				setfillstyle(SOLID_FILL,BLACK);
				bar(0,0,460,480);//erase the play area
				setfillstyle(SOLID_FILL,DARKGRAY);
				bar(460,250,640,400);
				sprintf(str,"Lifes: %d",life);
				outtextxy(500,250,str);
			    }
			}
			for(i=0;i<60;i++)
				star[i].shownext();
			for(i=0;i<total_bullets;i++)
			{
				bullet[i].shownext();
				for(j=0;j<5;j++)
					if(bullet[i].present_flag&&asteroid[j].gothit(bullet[i].x,bullet[i].y))
					{
						bullet[i].destroy();
						score+=10;
						setfillstyle(SOLID_FILL,DARKGRAY);
						bar(500,200,630,250);
						sprintf(str,"Score: %d",score);
						outtextxy(500,200,str);
						total_hits++;
						if(total_hits==5)//All the 5 Asteroids Got hit
						{
						score+=(fuel*5);//add the Fuel remaining as bonus point to score
						return TRUE; //Return true to indicate the level completed
						}
					}
			}
			s_craft.shownext();
			delay(speed);
			setfillstyle(SOLID_FILL,WHITE);//erase used fuel Area
			bar(490+fuel,430,590,435);
			fuel-=0.03;//reduce the fuel
		}
		key=getch();
		if(key==75)//Left arrow
			s_craft.xmove=-1;
		if(key==77)//Right Arrow
			s_craft.xmove=1;
		if(key==80)//Down Arrow
			s_craft.xmove=0;
		if(key==32&&total_bullets<50) //space bar is hit
		{
			bullet[total_bullets].start(s_craft.x+19);
			total_bullets++;
		}
	}
return FALSE;//Return False to indicate level not completed
}

void intro_screen()
{
	line(120,100,150,70);
	line(120,100,125,100);
	line(120,100,120,95);
	settextstyle(1,0,1);
	outtextxy(10,40,"This is the Space Craft You Get.");
	outtextxy(50,270,"The Bullet");
	outtextxy(120,150,"These are the Asteroids in Space.");
	line(220,200,250,170);
	line(220,200,225,200);
	line(220,200,220,195);
	setcolor(RED);
	outtextxy(150,320,"Your Goal:");
	setcolor(14);
	outtextxy(150,360,"Hit All the Asteroids With the limited Fuel Usage");
	setcolor(GREEN);
	settextstyle(2,0,8);
	outtextxy(350,40,"Controls:");
	settextstyle(2,0,6);
	outtextxy(350,70,"Move Left : Left  Arrow [<-]");
	outtextxy(350,85,"Move Right: Right Arrow [->]");
	outtextxy(350,100,"Stop      : Down Arrow");
	outtextxy(350,115,"Fire      : Space Bar");
	settextstyle(7,0,4);
	setcolor(14);
	outtextxy(100,400,"Hit any key to Start . . .");
	getch();
}

