#include"iostream.h"
#include"graphics.h"
#include"stdlib.h"
#include"conio.h"
#include"mouse.h"
#include"stdio.h"
int level=1;
class windows
{
	public: void show(int,int,int,int,char*);
};

void windows::show(int x1,int y1,int x2, int y2,char *title)
{
setcolor(DARKGRAY);
line(x1+1,y2+1,x2+1,y2+1);
line(x2+1,y1+1,x2+1,y2+1);
setfillstyle(SOLID_FILL,LIGHTGRAY);
bar(x1,y1,x2,y2);//window color
setfillstyle(SOLID_FILL,BLUE);
bar(x1,y1,x2,y1+15);//title bar
settextstyle(14,0,1);
setcolor(WHITE);
outtextxy(x1+5,y1+5,title);
line(x1,y1,x2,y1);
line(x1,y1,x1,y2);
setcolor(DARKGRAY);
}

class cmdbutton
{
       int x1,y1,x2,y2;
       int tx,ty;//coordinates for printing the command label
       char *label;
       public:
       void show(int,int,int,int,char*);
       int mouseclick();
};

void cmdbutton::show(int cx1,int cy1,int cx2,int cy2,char *str)
{

	setfillstyle(SOLID_FILL,LIGHTGRAY);//the command button color fill
	bar(cx1,cy1,cx2,cy2); //draw close button
	setcolor(WHITE);
	line(cx1,cy1,cx2,cy1);// top line
	line(cx1,cy1,cx1,cy2);// left line
	setcolor(DARKGRAY);
	line(cx2,cy1,cx2,cy2);//right line
	line(cx1,cy2,cx2,cy2);//bottom line
	x1=cx1;
	x2=cx2;
	y1=cy1;
	y2=cy2;
	label=str;
	setcolor(DARKGRAY);
	tx=x1+((x2-x1)/2); //get center x value
	ty=y1+((y2-y1)/2); //get center y value
	settextjustify(1,1); //center justify
	settextstyle(14,0,2);
	outtextxy(tx,ty,label);
	settextjustify(0,2);//set back to default justify
}

int cmdbutton::mouseclick()
{
	int button,bx,by;
	getmousepos(&button,&bx,&by);
	if(button&1==1 && bx>=x1 &&bx<=x2 && by>=y1 && by<=y2)
		{
		hidemouseptr();
		setcolor(DARKGRAY);
		line(x1,y1,x2,y1);// top  button line
		line(x1,y1,x1,y2);// left button line
		setcolor(WHITE);
		line(x2,y1,x2,y2);//right line
		line(x1,y2,x2,y2);//bottom line
		settextjustify(1,1); //center justify
		settextstyle(14,0,2);
		setcolor(LIGHTGRAY);
		outtextxy(tx,ty,label);//erase label
		setcolor(DARKGRAY);
		outtextxy(tx+1,ty+1,label);//print label in new positon
		showmouseptr();
		while(button&1==1)  //wait until the mouse click is released
			{
			getmousepos(&button,&bx,&by);
			}
		hidemouseptr();
		setcolor(WHITE);
		line(x1,y1,x2,y1);// top  button line
		line(x1,y1,x1,y2);// left button line
		setcolor(DARKGRAY);
		line(x2,y1,x2,y2);//right line
		line(x1,y2,x2,y2);//bottom line
		setcolor(LIGHTGRAY);
		outtextxy(tx+1,ty+1,label);//erase the label
		setcolor(DARKGRAY);
		outtextxy(tx,ty,label);//restore label to previos position
		settextjustify(0,2);//set back to default justify
		showmouseptr();
		return 1;
		}
		else
		return 0;
}

class bitmaps
{
public:
void *balloon1[2];
void *balloon2[2];
void *arrow;
void showman1();
void initballoon1();
void initballoon2();
void initarrow();
~bitmaps()
	{
	free(balloon1[0]);
	free(balloon2[0]);
	free(balloon1[1]);
	free(balloon2[1]);
	free(arrow);
	}
};

void bitmaps::initballoon1()//the fatty full balloon
{
setcolor(WHITE);
setfillstyle(SOLID_FILL,RED);
circle(100,200,15);
floodfill(100,200,WHITE);
setcolor(YELLOW);
line(100,215,100,240);
balloon1[0]=malloc(imagesize(84,184,116,241));//allocate the red balloon
getimage(84,184,116,241,balloon1[0]);
	setfillstyle(SOLID_FILL,YELLOW);//make the balloon yellow
	floodfill(100,200,WHITE);
	balloon1[1]=malloc(imagesize(84,184,116,241));//allocate the Yellow balloon
	getimage(84,184,116,241,balloon1[1]);

}

void bitmaps::initballoon2()//the slim pissed off balloon
{
setfillstyle(SOLID_FILL,RED);
setcolor(WHITE);
fillellipse(150,200,6,15);
setcolor(YELLOW);
line(150,215,150,240);
balloon2[0]=malloc(imagesize(143,184,157,241));
getimage(143,184,157,241,balloon2[0]);
setfillstyle(SOLID_FILL,YELLOW);
setcolor(WHITE);
fillellipse(150,200,6,15);
balloon2[1]=malloc(imagesize(143,184,157,241));
getimage(143,184,157,241,balloon2[1]);
}

void bitmaps::initarrow()
{
setcolor(DARKGRAY);
line(110,50,150,50);
setcolor(LIGHTRED);
outtextxy(150,48,"");
arrow=malloc(imagesize(109,48,157,54));
getimage(109,48,157,54,arrow);
}

void bitmaps::showman1()
{
	    int poly1[6]={67,63,67,85,90,85};                        //hat
	    int poly2[10]={67,85,67,107,75,112,90,107,90,85};        //face
	    int poly3[12]={67,85,67,100,70,86,75,95,80,87,90,85};    //hair arc
	    int poly4[16]={90,120,62,120,62,145,93,145,93,130,102,130,102,120,90,120};//shirt full
	    int poly5[14]={66,145,62,157,75,159,80,145,80,159,96,157,89,145};//shorts
	    int poly6[8]={69,157,69,165,74,165,74,157};         //left leg
	    int poly7[8]={82,157,82,165,88,165,88,157};         //right leg
	    int poly8[10]={67,166,67,172,56,177,74,177,74,166}; //left shoes
	    int poly9[10]={80,166,80,178,92,178,88,175,88,166}; //right shoes
	    int poly10[8]={61,112,58,108,65,105,69,112};        //arrow holder
	    int poly11[16]={67,135,67,140,73,140,73,135,72,136,71,135,
	    68,138,67,135};       //left pocket
	    int poly12[16]={85,135,85,140,89,140,89,135,88,137,87,135,86,
	    137,85,135};           //right pocket
	   //bow
		     setcolor(6);
		     arc(37,120,330,30,100);
		     arc(37,120,330,30,101);
		     arc(37,120,330,30,102);
		     arc(134,66,120,238,10);
		     arc(135,171,120,238,10);
		     setcolor(15);
		     line(125,75,125,165);
	    //hat
		    setcolor(10);
		    setfillstyle(SOLID_FILL,10);
		    fillpoly(3,poly1);
	     //face
		     setcolor(14);
		     setfillstyle(SOLID_FILL,14);
		     fillpoly(5,poly2);
	    //hairarc
		     setcolor(12);
		     setfillstyle(SOLID_FILL,12);
		     fillpoly(6,poly3);
	     //eyes
		     setcolor(0);
		     circle(81,95,1);
		     circle(88,95,1);
	     //nose
		     setcolor(0);
		     line(60+26,130-27,60+30,130-27);
		     line(60+26,130-32,60+30,130-27);
	     //neck
		     setcolor(12);
		     setfillstyle(SOLID_FILL,12);
		     bar(69,109,82,118);
	    //shirt sleaves right
		    setcolor(1);
		    setfillstyle(SOLID_FILL,11);
		    bar(62,112,90,119);
	    //arrow holder
		    setcolor(6);
		    setfillstyle(SOLID_FILL,6);
		    fillpoly(4,poly10);
	    //arrows in the holder
		   setcolor(4);
		   line(56,102,60,110);
		   outtextxy(54,100,"^");
		   line(58,102,62,110);
	   //shirt full
		   setcolor(11);
		   setfillstyle(SOLID_FILL,11);
		   fillpoly(8,poly4);
	  //pocket left
		   setcolor(8);
		   setfillstyle(SOLID_FILL,8);
		   fillpoly(8,poly11);
	  //pocket right
		   setcolor(8);
		   setfillstyle(SOLID_FILL,8);
		   fillpoly(8,poly12);
	 //arrow holder belt
		   setcolor(6);
		   line(70,120,94,146);
		   line(70,121,94,147);
		   line(70,122,94,148);

	 /*  hands */
	 //left
		   setcolor(14);
		   setfillstyle(SOLID_FILL,14);
		   bar(90,112,120,118);
		   fillellipse(121,115,3,4);
		   setcolor(0);
		   arc(119,110,280,360,5);            //finger
	  //right
		   setcolor(14);
		   bar(102,122,132,128);
		   fillellipse(135,125,3,5);
		   setcolor(0);
		   arc(133,120,250,360,5);        //finger
	  //shirt buttons
		   setcolor(1);
		   circle(80,123,1);
		   circle(80,129,1);
	  /* legs */
	  //left leg
		   setcolor(14);
		   setfillstyle(SOLID_FILL,14);
		   fillpoly(4,poly6);
	 //right leg
		   setcolor(14);
		   setfillstyle(SOLID_FILL,10);
		   fillpoly(4,poly7);
	 /* shorts */
		   setcolor(10);
		   setfillstyle(SOLID_FILL,10);
		   fillpoly(7,poly5);
	 //short paturboc3h
		   setcolor(7);
		   setfillstyle(SOLID_FILL,7);
		   bar(67,148,70,152);
	 /*  shoes  */
	 //left
		   setcolor(10);
		   setfillstyle(SOLID_FILL,10);
		   fillpoly(5,poly8);
		   bar(65,166,75,168);
	  //right
		   setcolor(10);
		   setfillstyle(SOLID_FILL,10);
		   fillpoly(5,poly9);
		   bar(78,166,90,168);
	}

bitmaps bmp;
class balloons
{
int x,y,xstart;
int ymove;
void *balloon_bmp;
int balloon_no;
public:
int present_flag;

	balloons()
	{
	y=403;//the starting position of the balloon
	present_flag=1;
	}
	void setxpos(int xpos)
		{
		x=xpos;
		ymove=-1;
		balloon_bmp=bmp.balloon1[0];
		xstart=xpos;
		}
	void reset(int no)
		{
		putimage(x,y+1,balloon_bmp,XOR_PUT);//erase the balloon
		x=xstart;
		y=403;
		ymove=-1;
		balloon_bmp=bmp.balloon1[no];
		balloon_no=no;
		present_flag=1;
		}

	void shownext()
	{
	if(present_flag)
		{
		putimage(x,y,balloon_bmp,COPY_PUT);
		y=y+ymove;
		}
	if(ymove==1&&y==403) //the falling balloon has reached the ground
		{
		putimage(x,y-1,balloon_bmp,XOR_PUT);//erase balloon
		ymove=0;
		present_flag=0;
		}
	if(y==20&&present_flag)
	       {
		y++;
		putimage(x,y,balloon_bmp,XOR_PUT);//erase balloon
		y=403;//putback to the start position
		}
	}
	int got_hit(int xarrow,int yarrow)
		{

			if( (x+16)-(xarrow+48)<16&&(x+16)-(xarrow+48)>0  && (y+16)-(yarrow+2)<16&&(y+16)-(yarrow+2)>-16&&ymove==-1)
				{
				putimage(x,y+1,balloon_bmp,XOR_PUT);//erase balloon
				balloon_bmp=bmp.balloon2[balloon_no];
				ymove=1;
				return 1;
				}
				else
				return 0;
		}

};

class arrows
{
public:
int x;
int xmove;
int loaded_flag;
	void load()
		{
		putimage(x,115,bmp.arrow,XOR_PUT);
		loaded_flag=1;
		}

	int loaded()
	{
	return loaded_flag;
	}

	void start()
	{
	xmove=1;
	}

	void reset()
	{
	if(x>=600)
	putimage(x-10,115,bmp.arrow,XOR_PUT);//erse the arrow
	x=120;
	xmove=0;
	loaded_flag=0;
	}
	void shownext()
	{
		if(xmove)
		{
		if(x<150)
			{
			putimage(x,115,bmp.arrow,XOR_PUT);//erase previous image;
			x+=xmove;
			putimage(x,115,bmp.arrow,XOR_PUT);
			}
			else
			{
			x+=xmove;
			putimage(x,115,bmp.arrow,COPY_PUT);
			}
		}


	}

	arrows()
	{
	x=120;
	xmove=0;
	loaded_flag=0;
	}
};

int main()
{
int gd=DETECT,gm;
initgraph(&gd,&gm,"");
setbkcolor(CYAN);
bmp.initballoon1();
bmp.initballoon2();
bmp.initarrow();
cleardevice();
balloons b[10];
arrows arr[10];
bmp.showman1();
setfillstyle(SOLID_FILL,LIGHTGRAY);
setcolor(DARKGRAY);
bar(0,0,639,20);
bar(0,461,639,479);
line(0,20,639,20); //border1
line(0,461,639,461);//border2
outtextxy(130,465,"Arrows Remaining: 10");
outtextxy(330,465,"Score: 0");
outtextxy(30,465,"Level: 1");
cmdbutton exitbutton,helpbutton,shootbutton,newbutton,loadbutton;
initmouse();
showmouseptr();
exitbutton.show(580,4,630,18,"Exit");
helpbutton.show(305,4,355,18,"Help");
shootbutton.show(50,180,100,195,"Shoot");
loadbutton.show(15,105,55,120,"Load");
newbutton.show(10,4,60,18,"New");
windows msgwindow;
for(int i=0;i<10;i++)
	{
	b[i].setxpos(215+i*43);
	b[i].reset(0);
	}
//arr[0].load();
int arrows_remaining=10;
int curr_arrow=0,j;
int score=0,delay_time=0;
char scr[4],arr_rem[4];
while(1)
	{
	for(i=0;i<10;i++)
	{
	b[i].shownext();
		for(j=0;j<curr_arrow;j++)
		{
		if(b[i].got_hit(arr[j].x,115))
		{
		score=score+10;
		delay_time++;
		sprintf(scr,"%d",score);
		bar(385,465,410,475);
		outtextxy(385,465,scr);
		}
		}
	}
	for(i=0;i<curr_arrow;i++)
		{
		arr[i].shownext();
		if(arr[i].x>600)
		arr[i].reset();
		}
	if(loadbutton.mouseclick())
	{
	if(curr_arrow<10)
	arr[curr_arrow].load();
	}
	if(shootbutton.mouseclick())
		{
		    if(arr[curr_arrow].loaded()&&curr_arrow<10)
			{
			arrows_remaining--;
			arr[curr_arrow].start();
			curr_arrow++;
			sprintf(arr_rem,"%d",arrows_remaining);
			bar(270,465,320,475);
			outtextxy(280,465,arr_rem);
			}
		}
	if(newbutton.mouseclick())
		{
		for(i=0;i<10;i++)
		b[i].reset(0);
		for(i=0;i<curr_arrow;i++)
		arr[i].reset();
		curr_arrow=0;
		arrows_remaining=10;
		setfillstyle(SOLID_FILL,LIGHTGRAY);
		sprintf(arr_rem,"%d",arrows_remaining);
		bar(270,465,320,475);
		outtextxy(280,465,arr_rem);
		score=0;
		sprintf(scr,"%d",score);
		bar(385,465,410,475);
		outtextxy(385,465,scr);
		delay_time=0;
		}

	if(exitbutton.mouseclick())
	break;

	if(score==100)
		{
		level++;
		break;
		}

	if(curr_arrow==10&&arr[9].x>=600&&score<100)//if the last arrow shooting is over
		{
		arr[9].x++;
		arr[9].reset();//close the arrow
		msgwindow.show(210,150,450,230,"Game Over");
		settextstyle(2,0,4);
		outtextxy(230,180,"The Archer Failed To Shoot them all");
		cmdbutton okbutton;
		okbutton.show(300,210,350,225,"Ok");
		while(!okbutton.mouseclick());
		setfillstyle(SOLID_FILL,CYAN);
		hidemouseptr();
		bar(210,150,453,233);
		showmouseptr();
		}
	delay(delay_time);
	}//here finishes the first level

if(level==2)//if the player reached the second level
{

	msgwindow.show(210,150,450,230,"Congrats!");
	settextstyle(2,0,4);
	outtextxy(220,180,"The Archer Has reached the Second Level");
	outtextxy(220,195,"Shoot Only the Yellow Balloons out!");
	cmdbutton okbutton;
	okbutton.show(300,210,350,225,"Ok");
	bar(30,465,120,475);
	outtextxy(30,465,"Level: 2");
	while(!okbutton.mouseclick());
	setfillstyle(SOLID_FILL,CYAN);
	hidemouseptr();
	bar(210,150,453,233);
	showmouseptr();

		for(i=0;i<10;i++)
		{
		if(i%2==0)
		b[i].reset(0); //to make alternative ballooons yellow
		else
		b[i].reset(1);
		}
		for(i=0;i<curr_arrow;i++)
		arr[i].reset();
		curr_arrow=0;
		arrows_remaining=arrows_remaining+5;
		int total_arrows=arrows_remaining;
		setfillstyle(SOLID_FILL,LIGHTGRAY);
		sprintf(arr_rem,"%d",arrows_remaining);
		bar(270,465,320,475);
		outtextxy(280,465,arr_rem);
		sprintf(scr,"%d",score);
		bar(385,465,410,475);
		outtextxy(385,465,scr);
		delay_time=0;

	while(1)
		{
		for(i=0;i<10;i++)
		{
		b[i].shownext();
			for(j=0;j<curr_arrow;j++)
			{
			if(b[i].got_hit(arr[j].x,115))
				{
				if(i%2==0)//if Yellow balloon is hit decrease the score
				score=score-10;
				else
				score=score+10;
				delay_time++;
				sprintf(scr,"%d",score);
				bar(385,465,410,475);
				outtextxy(385,465,scr);
				}
			}
		}
		if(score==150)
			{
			msgwindow.show(210,150,450,230,"Congrats!");
			settextstyle(2,0,4);
			outtextxy(220,180,"You have finished the game!");
			cmdbutton okbutton;
			okbutton.show(300,210,350,225,"Ok");
			while(!okbutton.mouseclick());
			setfillstyle(SOLID_FILL,CYAN);
			hidemouseptr();
			bar(210,150,453,233);
			showmouseptr();
			break;
			}
		for(i=0;i<curr_arrow;i++)
			{
			arr[i].shownext();
			if(arr[i].x>600)
			arr[i].reset();
			}
		if(loadbutton.mouseclick())
		{
		if(curr_arrow<total_arrows)
		arr[curr_arrow].load();
		}
		if(shootbutton.mouseclick())
			{
			    if(arr[curr_arrow].loaded()&&curr_arrow<total_arrows)
				{
				arrows_remaining--;
				arr[curr_arrow].start();
				curr_arrow++;
				sprintf(arr_rem,"%d",arrows_remaining);
				bar(270,465,320,475);
				outtextxy(280,465,arr_rem);
				}
			}
		if(newbutton.mouseclick())
			{
			for(i=0;i<10;i++)
			{
			if(i%2==0)
			b[i].reset(0); //to make alternative ballooons yellow
			else
			b[i].reset(1);
			}
			for(i=0;i<curr_arrow;i++)
			arr[i].reset();
			curr_arrow=0;
			arrows_remaining=5;
			setfillstyle(SOLID_FILL,LIGHTGRAY);
			sprintf(arr_rem,"%d",arrows_remaining);
			bar(270,465,320,475);
			outtextxy(280,465,arr_rem);
			score=100;
			sprintf(scr,"%d",score);
			bar(385,465,410,475);
			outtextxy(385,465,scr);
			delay_time=0;
			}

		if(exitbutton.mouseclick())
		break;

		if(curr_arrow==total_arrows&&arr[total_arrows-1].x>=600&&score<150)//if the last arrow shooting is over
			{
			arr[9].x++;
			arr[9].reset();//close the arrow
			msgwindow.show(190,150,490,230,"Game Over");
			settextstyle(2,0,4);
			outtextxy(193,180,"The Archer Failed To Shoot Only the Yellow Balloons");
			cmdbutton okbutton;
			okbutton.show(310,210,350,225,"Ok");
			while(!okbutton.mouseclick());
			setfillstyle(SOLID_FILL,CYAN);
			hidemouseptr();
			bar(193,150,493,233);
			showmouseptr();
			}
		delay(delay_time);
		}
}//here finishes the Second level

closegraph();
return 0;
}