//The Main File of Petrol Station Simulation Project
#include"pb_class.cpp"
#define DRIVER_PATH "d:\tc"

void main()
{
	int Gd = DETECT, Gm;
	installuserdriver("Svga256",DetectVGA256);
	initgraph(&Gd,&Gm,DRIVER_PATH);
	InitMouse();
	ShowMouse();
	Options option;
	vehicle *Q1[5],*Q2[5];
	vehicle *depart_veh,*depart_veh2;
	Report_generator report_gen;
	int depart_veh_present=FALSE;
	int depart_veh_present2=FALSE;
	int next_veh_time;
	int no_veh=0,no_veh2=0,curr_veh;
	int mintime;
	int rand_time;
	option.welcome();
	int option_chosen=4;

	while(option_chosen!=1)
	{
		option_chosen=option.Get_options();

		if(option_chosen==2)//help is chosen
		{
			cmdbutton returnbutton;
			HideMouse();
			drawbmp("pb_help.bmp",35,55);
			returnbutton.show(350,500,420,520,"Return");
			ShowMouse();
			while(!returnbutton.mouseclick());
		}
		if(option_chosen==0)
		{
			closegraph();
			exit(0);
		}
	}
	cleardevice();
	HideMouse();
	randomize();
	vb.initveh();//initialize the bmp's for vehicles
	cleardevice();
	pump t;
	setfillstyle(SOLID_FILL,138);//printing the status bar
	bar(5,510,795,590);
	setcolor(WHITE);
	line(5,510,795,510);//top border
	line(5,510,5,590);//left border
	setcolor(222);
	outtextxy(300,520,"Total Vehicles:");
	outtextxy(300,550,"Fuel Remaining:");
	t.showpump(option.no_of_pumps);
	if(option.hour==peak_hour)
	mintime=5;
	if(option.hour==moderate_hour)
	mintime=10;
	if(option.hour==offpeak_hour)
	mintime=15;
	rand_time=(rand()%5)+mintime;
	next_veh_time=current_time();
	repfile.open("report.dat",ios::out|ios::binary|ios::in);//open report file for writing
	refresh_time=current_time();

	if(option.no_of_pumps==1)//if single pump simulation is choosed, start the simulation
	{
		while(Options::tank_capacity>0&&!kbhit())
		{
			if(current_time()>=next_veh_time)//if its time for the next arrival of a Vehicle
			{
				if(no_veh<5)//if number of vehicles in Queue1 is less than 5
				 {
					 Q1[no_veh]=create_random_vehicle(TANK1_POS);//Create a new Arrival of vehicle
					 no_veh++;
				 }
				 rand_time=(rand()%5)+mintime;
				 next_veh_time=(current_time())+rand_time;//schedule the next arrival (BootStrapping)
			}

			for(curr_veh=0;curr_veh<no_veh;curr_veh++)//to move the vehicles in the tank1 queue
			Q1[curr_veh]->shownext(curr_veh);

			if(depart_veh_present)//if a Departing vehicle is present in Queue1
			{
				depart_veh->shownext(-1);
				if(depart_veh->xpos>=690)//erase Departing vehicle if it has reached the end position
				{
					setfillstyle(SOLID_FILL,BLACK);
					bar(690,120,800,188);
					depart_veh_present=0;
					delete depart_veh;
				}
			}

			if(refresh_time==current_time())//check time to refresh the status bar
			{
				if(fill_veh_present)
				Q1[0]->Print_Serve_status();
				Print_Station_status();
				refresh_time=current_time()+1; //set next refresh time after one second
			}

			if(Q1[0]->xpos==FIRST_POS) //if first vehicle in the queue1 has reached the pump
			{
				Q1[0]->Start_consuming(1);//Start the Fuel Consumption of first vehicle
				report_gen.Add_record(Q1[0]);
			}

			if(fill_veh_present&&current_time()>=fill_time)//if the filling is over, make the next vehicle in the queue as the present fill vehicle
			{
				depart_veh=Q1[0]; //current vehicle starts to Depart
				depart_veh_present=TRUE;
				fill_veh_present=FALSE;
				for(curr_veh=0;curr_veh<no_veh;curr_veh++)
				Q1[curr_veh]=Q1[curr_veh+1];
				no_veh--;
			}
		}//End of  While Loop

	}//end of single pump

	if(option.no_of_pumps==2)//if double pump simulation is choosen, start the simulation
	{
		while(Options::tank_capacity>0&&!kbhit())
		{
			if(current_time()>=next_veh_time)//if its time for the next arrival of a Vehicle
			{
				if(no_veh<5&& no_veh<=no_veh2)//if number of vehicles in Queue1 is less than 5 and Queue2 length is less than Queue1
				{
					 Q1[no_veh]=create_random_vehicle(TANK1_POS);//Create a new Arrival of vehicle in Queue1
					 no_veh++;
				}
				else
				if(no_veh2<5)//if number of vehicles in Queue2 is less than 5
				{
					 Q2[no_veh2]=create_random_vehicle(TANK2_POS);//Create a new Arrival of vehicle in Queue2
					 no_veh2++;
				}
				rand_time=(rand()%5)+mintime;
				next_veh_time=(current_time())+rand_time;//schedule the next arrival (BootStrapping)
			}

			for(curr_veh=0;curr_veh<no_veh;curr_veh++)//to move the vehicles in the tank1 queue
			Q1[curr_veh]->shownext(curr_veh);

			for(curr_veh=0;curr_veh<no_veh2;curr_veh++)//to move the vehicles in the tank2 queue
			Q2[curr_veh]->shownext(curr_veh);

			if(depart_veh_present)//if a Departing vehicle is present in Queue1
			{
				depart_veh->shownext(-1);
				if(depart_veh->xpos>=690)//erase Departing vehicle if it has reached the end position
				{
					setfillstyle(SOLID_FILL,BLACK);
					bar(690,120,800,188);
					depart_veh_present=FALSE;
					delete depart_veh;
				}
			 }

			 if(depart_veh_present2)//if a Departing vehicle is present in Queue2
			 {
				depart_veh2->shownext(-1);
				if(depart_veh2->xpos>=690)//erase Departing vehicle if it has reached the end position
				{
					setfillstyle(SOLID_FILL,BLACK);
					bar(690,330,800,398);
					depart_veh_present2=FALSE;
					delete depart_veh2;
				}
			 }

			 if(refresh_time==current_time())//check time to refresh the status bar
			 {
				if(fill_veh_present)//if the vehicle present on pump1
				Q1[0]->Print_Serve_status();//print the status of the vehicle

				if(fill_veh_present2)//if vehicle present on pump2
				Q2[0]->Print_Serve_status2();//print the status of the vehicle

				Print_Station_status();//print the Station fuel status
				refresh_time=current_time()+1;
			 }

			 if(Q1[0]->xpos==FIRST_POS) //if first vehicle in the queue1 has reached the pump
			 {
				Q1[0]->Start_consuming(1);
				report_gen.Add_record(Q1[0]);
			 }

			 if(Q2[0]->xpos==FIRST_POS) //if first vehicle in the queue2 has reached the pump
			 {
				Q2[0]->Start_consuming(2);
				report_gen.Add_record(Q2[0]);
			 }

			 if(fill_veh_present&&current_time()>=fill_time)//if the filling is over, make the next vehicle in the queue1 as the present fill vehicle
			 {
				depart_veh=Q1[0]; //current vehicle starts to Depart
				depart_veh_present=TRUE;
				fill_veh_present=FALSE;
				for(curr_veh=0;curr_veh<no_veh;curr_veh++)
				Q1[curr_veh]=Q1[curr_veh+1];
				no_veh--;
			 }

			 if(fill_veh_present2&&current_time()>=fill_time2)//if the filling is over, make the next vehicle in the queue2 as the present fill vehicle
			 {
				depart_veh2=Q2[0]; //current vehicle starts to Depart
				depart_veh_present2=TRUE;
				fill_veh_present2=FALSE;
				for(curr_veh=0;curr_veh<no_veh;curr_veh++)
				Q2[curr_veh]=Q2[curr_veh+1];
				no_veh2--;
			 }

		    }//End of While Loop

		}//end of Double pump Simulation

		for(curr_veh=0;curr_veh<no_veh;curr_veh++)//remove remaining vehicles in the queue1 from memory
		delete Q1[curr_veh];

		for(curr_veh=0;curr_veh<no_veh2;curr_veh++)//remove remaining vehicles in the queue2 from memory
		delete Q2[curr_veh];

		closegraph();
		initgraph(&Gd,&Gm,DRIVER_PATH);

		if(Options::tank_capacity==0)//if tank got empty
		{
			windows infowindow;
			infowindow.show(250,225,550,350,"Information");//draw window background
			int a[]={300,260,280,300,320,300,300,260};
			setfillstyle(SOLID_FILL,YELLOW);
			fillpoly(4,a);
			outtextxy(300,290,"!");
			outtextxy(350,275,"Tank is empty");
			cmdbutton okbutton;
			okbutton.show(375,320,425,340,"Ok");
			ShowMouse();
			while(!okbutton.mouseclick());
		}
	repfile.close();
	while(report_gen.Display_menu()!=1);//Display Report Menu Until it is closed
	closegraph();
}//here ends the Main program
