/* Program to simulate a  Text Editor  similar to  Notepad in  Windows */
/* This particular editor is called Composer Ver.  1.00,  and was done */
/* as one of the requirements for the III Semester MCA under Bangalore */
/* University. The design of this Editor was carried out in April 2001 */

/* The standard header files to be included are named here */
# include <stdio.h>
# include <conio.h>
# include <alloc.h>
# include <dos.h>
# include <process.h>
# include <ctype.h>
# include <string.h>
# include <math.h>
# include <bios.h>

/* Standard codes are defined here, along with relevant constants */
# define ALTF     33
# define ALTS     31
# define ALTA     30
# define ALTH     35
# define F1	  59
# define F2       60
# define F3       61
# define F4       62
# define F5       63
# define F6       64
# define F10      68
# define LEFT     75
# define RIGHT    77
# define UP       72
# define DOWN     80
# define ESC      27
# define ENTER    13
# define INS      82
# define HOME	  71
# define PGUP	  73
# define DEL      83
# define END	  79
# define PGDOWN   81
# define BKSPACE   8
# define TAB	   9
# define SPACE    32
# define SHIFTF10 93
# define CTRLY	  25
# define CTRLHOME 119
# define CTRLEND  117
# define CTRLPGUP 132
# define CTRLPGDN 118
# define ALTX      45

# define normal textbackground(DARKGRAY),textcolor(WHITE);

#  define BIGG    'G'
# define SMALLG   'g'

#  define BIGN    'N'
# define SMALLN   'n'

#  define BIGL 	  'L'
# define SMALLL   'l'

#  define BIGS 	  'S'
# define SMALLS   's'

#  define BIGA 	  'A'
# define SMALLA   'a'

#  define BIGP 	  'P'
# define SMALLP   'p'

#  define BIGD 	  'D'
# define SMALLD   'd'

#  define BIGX 	  'X'
# define SMALLX   'x'

#  define BIGF 	  'F'
# define SMALLF   'f'

#  define BIGR 	  'R'
# define SMALLR   'r'

#  define BIGM 	  'M'
# define SMALLM   'm'

#  define BIGI 	  'I'
# define SMALLI   'i'

#  define BIGC 	  'C'
# define SMALLC   'c'

#  define BIGH 	  'H'
# define SMALLH   'h'

/* The basic data structure on which the application is based is defined here */
struct llist
{
	struct llist *lptr;
	char info[78];
	struct llist *rptr;
};
typedef struct llist nodeptr;
nodeptr *ptr,*nptr,*first = NULL,*tp,*tp1,*check,*cur,*prev;
char *FoundPtr;

int menuno; 	       /* Indicates menu that is selected */
int barno;  	       /* Indicates bar of menu that is selected */
int menuactivated = 0; /* Indicates whether or not a menu is activated */
int i;                 /* Simple Loop Variable */
int j;                 /* Simple Loop Variable */
int k;                 /* Simple Loop Variable */
int l=0;               /* Simple Loop Variable */
int LoopCtr;           /* Simple Loop Counter */
int Ascii;             /* Contains Ascii value of key pressed by user */
int Scan;              /* Indicates special code of key pressed by user */
int helpactivated;     /* Indicates that the help option is activated */
int helplastactivated=1;/* Indicates which help screen was last displayed */
int menupadactivated = 0;/* Indicates whether the menu bar is activated or not */
int menupadno=1;	/* Indicates which menupad is being chosen */
char buffer[4096];      /* Temporary storage for screen refresh operations */
int key;		/* stores key pressed by user */
union REGS inregs;      /* Union used for issuing interrupts */
union REGS outregs;	/* Union used for issuing interrupts */
int row;                /* Indicates row where edit operation is being done */
int col;		/* Indicates column where edit operation is being done */
int flag = 1;		/* Indicates a change has been made to file contents */
int sav = 0;		/* Indicates whether a save operation needs to be done */
int temp;		/* Temporary numeric variable for row computations */
char cha;		/* Character variable that stores a character of a string */
char c;			/* Character variable that indicates continuity */
char filename[42];      /* Indicates file where operation is taking place */
char fname[42]={"NONAME"};/* Indicates file where operation is taking place */
char tempname[42];        /* Temporary name of while where operation to take place*/
int Ins = 1;		  /* Shows status of Insert Key */
char far *vidmem=(char far*) 0xb8000000;
char SearchStr[80];	  /* String to be found */

/* This function accepts a character from the user */
void GetKey()
{
	inregs.h.ah = 0;
	int86(22,&inregs,&outregs);
	Ascii = outregs.h.al;
	Scan = outregs.h.ah;
	return;
}

/* Displays current cursor location, filename, status of Insert key*/
void ShowCursorPosition()
{
		int length;
		gotoxy(2,24);textcolor(WHITE);
		textbackground(DARKGRAY);
		cprintf(" %d:%d ",row-2+l,col-1);
		textcolor(LIGHTBLUE);
		cprintf("");
		textcolor(WHITE);
		gotoxy(15,24);
		if (Ins == 1)
			cprintf(" INS ");
		else
			{textcolor(LIGHTBLUE);
			cprintf("");}
      textcolor(WHITE);
      if (sav==0)
			{gotoxy(26,24);cprintf("  ");}
      else
      	{textcolor(LIGHTBLUE);gotoxy(26,24);cprintf("");
	}
		gotoxy(35,24);
      textcolor(WHITE);
		length = strlen(fname);
		for (i=0; i<length; i++)
		{
		   fname[i] = toupper(fname[i]);
		}
		gotoxy(35,24);
		cprintf(" %s ",fname);
		textcolor(LIGHTBLUE);cprintf("");
		textcolor(WHITE);gotoxy(61,24);cprintf(" Composer Ver 1.00 ");
}

/* Used to save screen contents into a buffer */
void SaveScreenContents()
{
	window(1,1,80,25);
	gettext(1,1,80,25,buffer);
}

/* Used to restore screen contents from buffer */
void RestoreScreenContents()
{
	gotoxy(1,1);
	puttext(1,1,80,25,buffer);
}

/* Draws a box taking the corner coordinates as parameters */
void drawbox(int c1,int r1,int c2,int r2)
{
	int i;
	textcolor(LIGHTBLUE);
	textbackground(DARKGRAY);
	gotoxy(c1,r1);cprintf("");
	gotoxy(c2,r1);cprintf("");
	gotoxy(c1,r2);cprintf("");
	gotoxy(c2,r2);cprintf("");
	for (i=c1+1;i<c2;i++)
	{
		gotoxy(i,r1);cprintf("");
		gotoxy(i,r2);cprintf("");
	}
	for (i=r1+1;i<r2;i++)
	{
		gotoxy(c1,i);cprintf("");
		gotoxy(c2,i);cprintf("");
	}

}

/* Handles the DOS Shell option. Remember to run EXE file to make this work */
void shell()
{
	int status = 0;
	clrscr();
	printf("Quitting temporarily to DOS\n");
	printf("Type EXIT to return to Composer 1.00\n\n");
	status = system("C:\\COMMAND.COM");
	if (status == -1)
	{
		printf ("Cannot load COMMAND.COM\n");
		printf("Press any key to return to Composer 1.00\n");
		fflush(stdin);
		getch();
	}
	getch();
        Ascii=27;
}

/* Used to clear menu boxes and dialog boxes */
void clearbox(int c1,int r1,int c2,int r2)
{       int r,c;
	textbackground(DARKGRAY);
	for (r=r1;r<=r2;r++)
	{
		for (c=c1;c<=c2;c++)
		{
			gotoxy(c,r);
			cprintf(" ");
		}
	}
}

/* Used to clear menus and reprint border */
void clearmenu(int paramenuno)
{	int i,j,k;
	textbackground(DARKGRAY);
	if (paramenuno==1) clearbox(1,2,12,10);
	if (paramenuno==2) clearbox(13,2,24,9);
	if (paramenuno==3) clearbox(25,2,37,9);
	if (paramenuno==4) clearbox(40,2,58,9);
	menuactivated=0;menupadactivated = 0;
	RestoreScreenContents();
	drawbox(1,2,80,24);
	ShowCursorPosition();
	textbackground(DARKGRAY);
	gotoxy(1,1);textcolor(MAGENTA);
	cprintf(" F           S             A            H    ");
	textcolor(WHITE);
	gotoxy(3,1);cprintf("ile");
	gotoxy(15,1);cprintf("earch");
	gotoxy(29,1);cprintf("bout");
	gotoxy(42,1);cprintf("elp");
}

/* Creates a blankline */
void blankline()
{
	gotoxy(2,row);
	for (i=col;i<=79;++i)
		pokeb(0xb800,(row-1) * 160 + (i-1)*2,32);
	gotoxy(2,row);
	return;
}

/* Prints the message that Composer 1.00 does not right Scroll*/
void column()
{
	gettext(1,1,80,25,buffer);
	clearbox(10,6,70,11);
	drawbox(10,6,70,11);
	gotoxy(16,8);
	textcolor(WHITE);
	cprintf("Composer 1.00 does not support horizontal scrolling");
	gotoxy(16,9);
	cprintf("        Press any key to continue .............    ");
	getch();
	if (Scan == RIGHT) getch();
	fflush(stdin);
	puttext(1,1,80,25,buffer);
}

/* Moves the cursor one character right */
void right()
{
	if (col>=79)
	{
		column();
		return;
	}
	else
	{
		++col;
		gotoxy(col,row);
	}
}


/* Moves the cursor one character left */
void left()
{
	if (col<=2)
	{
		return;
	}
	else
	{
		--col;
		gotoxy(col,row);
	}
}


/* Function to scroll one line up */
void sc_up()
{
	++l;
	inregs.h.ah=0x06;
	inregs.h.al=1;
	inregs.h.bh=0x0b;
	inregs.h.ch=2;
	inregs.h.cl=1;
	inregs.h.dh=22;
	inregs.h.dl=78;
	int86(0x10,&inregs,&outregs);
	return;
}


/* Function to scroll one line down */
void sc_dn()
{
	--l;
	inregs.h.ah=0x07;
	inregs.h.al=1;
	inregs.h.bh=0x0b;
	inregs.h.ch=2;
	inregs.h.cl=1;
	inregs.h.dh=22;
	inregs.h.dl=78;
	int86(0x10,&inregs,&outregs);
	return;
}


/* Function to move the cursor one line up */
void lineup()
{
	if(first==NULL) return;

	if ((ptr->lptr!=NULL) && (row>3))
	{
		ptr = ptr->lptr;
		row--;textattr(BLACK + WHITE);
		gotoxy(col,row);
	}
	else
	if (ptr->lptr!=NULL)
	{
		ptr=ptr->lptr;
		sc_dn();
		gotoxy(2,row);
		textattr(BLACK + WHITE);
		for (i=0;ptr->info[i]!='\0';i++)
			cprintf("%c",ptr->info[i]);
	}
	ShowCursorPosition();
	return;
}


/* Function to move the cursor one line down */
void linedn()
{
	if(first==NULL) return;

	if ((ptr->rptr!=NULL) && (row<=22))
	{
		ptr = ptr->rptr;
		row++;
		gotoxy(col,row);
	}
	else
	if (ptr->rptr!=NULL)
	{
		ptr=ptr->rptr;
		sc_up();
		gotoxy(2,row);
		textcolor(WHITE);
		for (i=0;ptr->info[i]!='\0';i++)
			cprintf("%c",ptr->info[i]);
	}
	ShowCursorPosition();
	return;
}

/* Takes cursor to beginning of line */
void home()
{
	col = 2;
	gotoxy(2,row);
	ShowCursorPosition();
	return;
}

/* Takes cursor to end of line */
void end()
{
	int endr=0;
	while(ptr->info[endr]!='\0')
		endr++;
	col = endr + 2;
	gotoxy(col,row);
	ShowCursorPosition();
	return;
}

/* Takes cursor to beginning of file */
void ctr_pgup()
{
	if (first == NULL) return;

	row = 3;
	gotoxy(2,3);
	for (ptr=first;(row<=23) && (ptr->rptr!=NULL);row++,ptr=ptr->rptr)
	{
		blankline();textcolor(WHITE);
		for (i=0;ptr->info[i]!='\0';i++)
			cprintf("%c",ptr->info[i]);
	}
	row=3;
	l=0;
	gotoxy(2,3);
	ptr=first;
        home();
	ShowCursorPosition();
	return;
}

/* Takes the cursor to the end of file */
void ctr_pgdn()
{
	if ((first == NULL) || (first->rptr==NULL)) return;

	l=0;
	for (ptr=first;ptr->rptr!=NULL;l++,ptr=ptr->rptr)
	for (row=3;row<=23;row++)
	{
		col=2;
		blankline();
	}
	row=3;
	gotoxy(2,3);textcolor(WHITE);
	for(i=0;ptr->info[i]!='\0';i++)
		cprintf("%c",ptr->info[i]);
	return;
}


/* Used to scroll up a certain number of lines */
void ensc_up(int sr,int sc,int er,int ec)
{
	++l;
	inregs.h.ah=0x06;
	inregs.h.al=1;
	inregs.h.bh=0x0b;
	inregs.h.ch=sr;
	inregs.h.cl=sc;
	inregs.h.dh=er;
	inregs.h.dl=ec;
	int86(0x10,&inregs,&outregs);
	return;
}

/* Used to scroll down a certain number of lines */
void ensc_dn(int sr,int sc,int er,int ec)
{
	inregs.h.ah=0x07;
	inregs.h.al=1;
	inregs.h.bh=0x0b;
	inregs.h.ch=sr;
	inregs.h.cl=sc;
	inregs.h.dh=er;
	inregs.h.dl=ec;
	int86(0x10,&inregs,&outregs);
	return;
}

/* Deletes a line when CTRL Y is pressed */
void linedele()
{
	sav=0;
	if (first == NULL) return;
	flag = 0;
	if ((ptr->rptr !=NULL) && (ptr->lptr==NULL))
	{
		blankline();
		sc_up();
		if (l>0) --l;
		gotoxy(2,21);
		for (i=3,tp=first;(i<=21) && (tp!=NULL);i++,tp=tp->rptr);
		if (tp!=NULL)
		{	textcolor(WHITE);
			for (i=0;tp->info[i]!='\0';i++)
				cprintf("%c",tp->info[i]);
		}
		row=3;col=2;
		gotoxy(col,row);
		tp=ptr;
		ptr=ptr->rptr;
		first=ptr;
		ptr->lptr=NULL;
		free(tp);
		return;
	}

	if ((ptr->lptr == NULL) && (ptr->rptr == NULL))
	{
		blankline();
		tp=first;
		first = NULL;
		ptr = NULL;
		free(tp);
		return;
	}

	if (ptr->rptr==NULL)
	{
		tp=ptr;
		ptr=ptr->lptr;
		ptr->rptr=NULL;
		col=2;
		blankline();
		free(tp);
		--row;
		if (row<=3)
		{
			row=3;
			if(l>0) --l;
		}
		col=2;
		gotoxy(col,row);
		return;
	}
	ptr->rptr->lptr=ptr->lptr;
	ptr->lptr->rptr=ptr->rptr;
	ptr=ptr->rptr;

	blankline();
	ensc_up(row-1,1,21,77);
	if (l>0) --l;
	for (i=row,tp=ptr;(i<=21) && (tp->rptr!=NULL);i++,tp=tp->rptr);
	if (tp->rptr!=NULL)
	{
		gotoxy(2,21);
		temp=row;
		row=21;
		blankline();
		textcolor(WHITE);
		for (i=0;tp->info[i]!='\0';i++)
			cprintf("%c",tp->info[i]);
		row=temp;
	}
	col=2;
	gotoxy(col,row);
	return;
}

/* Goes to the bottom of the screen */
void ctr_end()
{
	if (first == NULL) return;
	for (tp=ptr;tp->rptr!=NULL && i<=21;i++,tp=tp->rptr);
	row = i;
	col=2;
	gotoxy(2,row);
	ptr=tp;
	return;
}

/* Goes to the top of the screen */
void ctr_home()
{
	if (first == NULL) return;
	for (tp=ptr,i=row;tp->lptr!=NULL && i>3;i--,tp=tp->lptr);
	row = i;
	col=2;
	gotoxy(2,row);
	ptr=tp;
	return;
}

/* Saves a file as ...*/
void SaveAsDialogBox()
{
	int option = 1;
	FILE *fptr;
	char tfname[42];
	clearmenu(1);
	RestoreScreenContents();
	SaveScreenContents();
	clearbox(20,10,60,20);
	drawbox(20,10,60,20);
	textcolor(WHITE);
	gotoxy(34,10);cprintf("Save File As");
	gotoxy(22,12);printf("Save File as");
	textbackground(LIGHTBLUE);
	for (i=22;i<=58;i++) {gotoxy(i,13);cprintf(" ");}
	textbackground(LIGHTBLUE);textcolor(WHITE);
	gotoxy(30,18);cprintf(" Save ");
	textbackground(DARKGRAY);textcolor(WHITE);
	gotoxy(45,18);cprintf(" Cancel ");
	gotoxy(22,13);gets(tfname);
	gotoxy(30,18);
	GetText: GetKey();
	if ((Scan!=LEFT) && (Scan!=RIGHT) && (Ascii!=TAB) && (Ascii!=ENTER)) goto GetText;
	if (((Scan == LEFT) || (Scan == RIGHT) || (Ascii == TAB)) && (option ==1))
	{
		textbackground(DARKGRAY);textcolor(WHITE);
		gotoxy(30,18);cprintf (" Save ");
		textbackground(LIGHTBLUE);textcolor(WHITE);
		gotoxy(45,18);cprintf (" Cancel ");
		option = 2;
		gotoxy(45,18);
		goto GetText;
	}

	if (((Scan == LEFT) || (Scan == RIGHT) || (Ascii == TAB)) && (option ==2))
	{
		textbackground(LIGHTBLUE);textcolor(WHITE);
		gotoxy(30,18);cprintf (" Save ");
		textbackground(DARKGRAY);textcolor(WHITE);
		gotoxy(45,18);cprintf (" Cancel ");
		option = 1;
		gotoxy(30,18);
		goto GetText;
	}

	if ((Ascii == ENTER) && (option ==2))
	{
		textbackground(DARKGRAY);
		RestoreScreenContents();
                Ascii=27;
		return;
	}

	if ((Ascii == ENTER) && (option ==1)) /* Save as fn to be called here*/
	{
		textbackground(DARKGRAY);
		RestoreScreenContents();
		SaveScreenContents();
		strcpy(fname,tfname);
		if (sav ==0) sav = 1;
		normal;
		fptr = fopen(fname,"w");
		if (fptr == NULL)
		{
			SaveScreenContents();
                        clearbox(20,6,60,10);
			drawbox(20,6,60,10);
			gotoxy(28,8);
			textcolor(WHITE);
			cprintf("Unable to open file.....");
			getch();
			RestoreScreenContents();
                        Ascii=27;
			return;
		}

		SaveScreenContents();
		for (tp=first;tp!=NULL;tp=tp->rptr)
		{
			for(i=0;tp->info[i]!='\0';i++)
				{
					cha = tp->info[i];
					putc(cha,fptr);
				}
			fputc('\n',fptr);
		}
		RestoreScreenContents();
		fclose(fptr);
		col=2;
		flag=1;sav=1;
		Ascii=27;return;
	}
}


/* Saves a file ...*/
void filesave()
{
	FILE *fptr;
	clearmenu(1);
	RestoreScreenContents();
	if (strcmpi(fname,"NONAME") == 0)
	{
		sav=1;
		SaveScreenContents();
		SaveAsDialogBox();
		RestoreScreenContents();
                Ascii=27;
		return;
	}
	fptr=fopen(fname,"w");
	if (fptr == NULL)
	{
		gettext(1,1,80,25,buffer);
		clearbox(20,7,60,11);
		drawbox(20,7,60,11);
		gotoxy(28,9);
		textcolor(WHITE);
		cprintf("Unable to open file.....");
		getch();
		puttext(1,1,80,25,buffer);
		return;
	}
	gettext(1,1,80,25,buffer);
	for (tp=first;tp!=NULL;tp=tp->rptr)
	{
		for (i=0;tp->info[i]!='\0';i++)
		{
			cha = tp->info[i];
			putc(cha,fptr);
		}
		fputc('\n',fptr);
	}
	RestoreScreenContents();
	fclose(fptr);
	col=2;
	flag=1;
	sav=1;
        Ascii=27;
	return;
}

/* Frees file space */
void filefree()
{	ptr=first;
	while (ptr!=NULL)
	{
		tp=ptr;
		ptr=ptr->rptr;
		free(tp);
	}
	return;
}

/* Creates a new node to be added to the list */
nodeptr *lnew()
{
	int i=0;
	check=(struct llist *) malloc (sizeof(struct llist));
	if (check == NULL)
	{
		gettext(1,1,80,25,buffer);
		clearbox(14,6,66,11);
		drawbox(14,6,66,11);
		textcolor(WHITE);
		gotoxy(23,8);
		cprintf("  MEMORY ALLOCATION NOT POSSIBLE...  ");
		gotoxy(23,9);
		cprintf("      TERMINATING APPLICATION ...    ");
		getch();
		puttext(1,1,80,25,buffer);
		exit(0);
	}
	else
	{
		for (i=0;i<79;i++)
			check->info[i]='\0';
	}
	return(check);
}

/* Check whether the file has been saved, and no changes have been made after*/
void checksave()
{
	if (sav == 0)
	{
		gettext(1,1,80,25,buffer);
		clearbox(10,6,70,10);
		drawbox(10,6,70,10);
		gotoxy(24,8);
		textcolor(WHITE);
		cprintf("FILE NOT SAVED! SAVE (Y/N)? : ");
		gotoxy(55,8);
		c=getch();
		if ((c=='Y') || (c=='y')) filesave();
		puttext(1,1,80,25,buffer);
	}
	return;
}

/* Stores character + attribute in VDU Memory */
void printch(char ch,int col,int lin)
{
	int i;
	char far *vid = vidmem;
	vid = vidmem+ 80 * (lin+1)*2 + (col*2);
	*vid = ch;
	vid++;
	*vid=15; /* Black Background, White Text */
}

/* Activate menu pad */
void activatepad(int padno)
{
	textbackground(LIGHTBLUE);
	menupadactivated = 1;
	if (padno == 1)
		textbackground(LIGHTBLUE);
	else
		textbackground(DARKGRAY);
	gotoxy(1,1);
	textcolor(MAGENTA);
	cprintf(" F");
	textcolor(WHITE);cprintf("ile ");

	if (padno == 2)
		textbackground(LIGHTBLUE);
	else
		textbackground(DARKGRAY);
	gotoxy(13,1);
	textcolor(MAGENTA);
	cprintf(" S");
	textcolor(WHITE);cprintf("earch ");

	if (padno == 3)
		textbackground(LIGHTBLUE);
	else
		textbackground(DARKGRAY);
	gotoxy(27,1);
	textcolor(MAGENTA);
	cprintf(" A");
	textcolor(WHITE);cprintf("bout ");

	if (padno == 4)
		textbackground(LIGHTBLUE);
	else
		textbackground(DARKGRAY);
	gotoxy(40,1);
	textcolor(MAGENTA);
	cprintf(" H");
	textcolor(WHITE);cprintf("elp ");
}

/* Print menu of File options */
void printfilemenu()
		{SaveScreenContents();
		gotoxy(1,1);
		textcolor(MAGENTA);
		textbackground(LIGHTBLUE);
		cprintf(" F");
		textcolor(WHITE);cprintf("ile ");
		menupadactivated = 1;
		drawbox(1,2,12,10);
		textcolor(MAGENTA);gotoxy(2,3);cprintf(" N");
		textcolor(LIGHTBLUE);cprintf("ew      ");

		textcolor(MAGENTA);gotoxy(2,4);cprintf(" L");
		textcolor(LIGHTBLUE);cprintf("oad     ");

		textcolor(MAGENTA);gotoxy(2,5);cprintf(" S");
		textcolor(LIGHTBLUE);cprintf("ave     ");

		gotoxy(2,6);cprintf(" S");
		textcolor(MAGENTA);cprintf("a");
		textcolor(LIGHTBLUE);cprintf("ve as  ");

		textcolor(MAGENTA);gotoxy(2,7);cprintf(" P");
		textcolor(LIGHTBLUE);cprintf("rint    ");

		textcolor(MAGENTA);gotoxy(2,8);cprintf(" D");
		textcolor(LIGHTBLUE);cprintf("OS Shell");
		gotoxy(2,9);cprintf(" E");
		textcolor(MAGENTA);cprintf("x");
		textcolor(LIGHTBLUE);cprintf("it     ");
		gotoxy(2,3);textbackground(LIGHTBLUE);textcolor(MAGENTA);
		cprintf(" N");
		textcolor(WHITE);cprintf("ew      ");
		menuno=1;
		barno=1;
		menuactivated=1;
		textbackground(DARKGRAY);textcolor(WHITE);}

/* Print menu of Search Options */
void printsearchmenu()
		{SaveScreenContents();
		gotoxy(13,1);
		textbackground(LIGHTBLUE);
		textcolor(MAGENTA);
		cprintf(" S");
		textcolor(WHITE);cprintf("earch ");
		menupadactivated = 1;
		drawbox(13,2,24,5);
		textcolor(MAGENTA);gotoxy(14,3);cprintf(" F");
		textcolor(LIGHTBLUE);cprintf("ind     ");
		textcolor(MAGENTA);gotoxy(14,4);cprintf(" G");
		textcolor(LIGHTBLUE);cprintf("oto Line");
		gotoxy(14,3);textbackground(LIGHTBLUE);textcolor(MAGENTA);
		cprintf(" F");
		textcolor(WHITE);cprintf("ind     ");
		menuno=2;
		barno=1;
		menuactivated=1;
		textbackground(DARKGRAY);textcolor(WHITE);		}

/* Print menu of About option*/
void printaboutmenu()
		{SaveScreenContents();
		gotoxy(27,1);
		textbackground(LIGHTBLUE);
		textcolor(MAGENTA);
		cprintf(" A");
		textcolor(WHITE);cprintf("bout ");
		menupadactivated = 1;
		menuno=3;
		barno=1;
		menuactivated=1;
		textbackground(DARKGRAY);textcolor(WHITE);
		}

/* Print menu of Help options */
void printhelpmenu()
		{SaveScreenContents();
		gotoxy(40,1);
		textbackground(LIGHTBLUE);
		textcolor(MAGENTA);
		cprintf(" H");
		textcolor(WHITE);cprintf("elp ");
		menupadactivated =1;
		menuno = 4;
		barno=1;
		menuactivated=1;
		drawbox(40,2,58,9);
		textcolor(MAGENTA);gotoxy(41,3);textbackground(LIGHTBLUE);cprintf(" F");
		textcolor(WHITE);cprintf("ile Commands   ");
		textbackground(DARKGRAY);
		textcolor(MAGENTA);gotoxy(41,4);cprintf(" S");
		textcolor(LIGHTBLUE);cprintf("earch Commands ");

		textcolor(MAGENTA);gotoxy(41,5);cprintf(" C");
		textcolor(LIGHTBLUE);cprintf("ursor Commands ");

		textcolor(MAGENTA);gotoxy(41,6);cprintf(" I");
		textcolor(LIGHTBLUE);cprintf("nsert Commands ");

		textcolor(MAGENTA);gotoxy(41,7);cprintf(" D");
		textcolor(LIGHTBLUE);cprintf("elete Commands ");

		textcolor(MAGENTA);gotoxy(41,8);cprintf(" M");
		textcolor(LIGHTBLUE);cprintf("iscellaneous ");

		textbackground(DARKGRAY);textcolor(WHITE);}



/* Moves menu bar up, if a menu is activated */
void movebarup(int paramenuno,int paramenubar)

{
if (paramenuno==1)
{
	if (paramenubar == 1)
	{
		gotoxy(2,3);
		textbackground(DARKGRAY);
		textcolor(MAGENTA);cprintf(" N");
		textcolor(LIGHTBLUE);cprintf("ew      ");
		textbackground(LIGHTBLUE);
		textcolor(WHITE);
		gotoxy(2,9);
		cprintf(" E it     ");
		textcolor(MAGENTA);gotoxy(4,9);cprintf("x");
		barno = 7;
	}

	if (paramenubar == 2)
	{
		gotoxy(2,4);
		textbackground(DARKGRAY);
		textcolor(MAGENTA);
		cprintf(" L");
		textcolor(LIGHTBLUE);cprintf("oad     ");
		textbackground(LIGHTBLUE);
		textcolor(WHITE);
		gotoxy(2,3);
		cprintf("  ew      ");
		gotoxy(2,3);textcolor(MAGENTA);
		cprintf(" N");
		barno = 1;
	}

	if (paramenubar == 3)
	{
		gotoxy(2,5);
		textbackground(DARKGRAY);
		textcolor(MAGENTA);cprintf(" S");
		textcolor(LIGHTBLUE);cprintf("ave     ");
		textbackground(LIGHTBLUE);
		textcolor(WHITE);
		gotoxy(2,4);
		cprintf("  oad     ");
		gotoxy(2,4);textcolor(MAGENTA);cprintf(" L");
		barno = 2;
	}

		if (paramenubar == 4)
	{
		gotoxy(2,6);
		textbackground(DARKGRAY);
		textcolor(LIGHTBLUE);
		cprintf(" S ve as  ");
		textcolor(MAGENTA);gotoxy(4,6);cprintf("a");
		textbackground(LIGHTBLUE);
		textcolor(WHITE);
		gotoxy(2,5);
		cprintf("  ave     ");
		textcolor(MAGENTA);gotoxy(2,5);cprintf(" S");
		barno = 3;
	}

	if (paramenubar == 5)
	{
		gotoxy(2,7);
		textbackground(DARKGRAY);
		textcolor(LIGHTBLUE);
		cprintf("  rint    ");
		textcolor(MAGENTA);gotoxy(2,7);cprintf(" P");
		textbackground(LIGHTBLUE);
		textcolor(WHITE);
		gotoxy(2,6);
		cprintf(" S ve as  ");
		textcolor(MAGENTA);gotoxy(4,6);cprintf("a");
		barno = 4;
	}

	if (paramenubar == 6)
	{
		gotoxy(2,8);
		textbackground(DARKGRAY);
		textcolor(MAGENTA);
		cprintf(" D");
		textcolor(LIGHTBLUE);cprintf("OS Shell");
		textbackground(LIGHTBLUE);
		textcolor(MAGENTA);
		gotoxy(2,7);
		cprintf(" P");
		textcolor(WHITE);cprintf("rint    ");
		barno = 5;
	}

		if (paramenubar == 7)
	{
		gotoxy(2,9);
		textbackground(DARKGRAY);
		textcolor(LIGHTBLUE);
		cprintf(" E it     ");
		textcolor(MAGENTA);gotoxy(4,9);cprintf("x");
		textbackground(LIGHTBLUE);
		textcolor(MAGENTA);
		gotoxy(2,8);
		cprintf(" D");
		textcolor(WHITE);cprintf("OS Shell");
		barno = 6;
	}
}

if (paramenuno==2)
{
	if (paramenubar == 1)
	{
		gotoxy(14,3);
		textbackground(DARKGRAY);
		textcolor(MAGENTA);cprintf(" F");
		textcolor(LIGHTBLUE);cprintf("ind     ");
		textbackground(LIGHTBLUE);textcolor(MAGENTA);
		gotoxy(14,4);cprintf(" G");
		textcolor(WHITE);cprintf("oto Line");
		barno = 2;
	}

	if (paramenubar == 2)
	{
		gotoxy(14,4);
		textbackground(DARKGRAY);
		textcolor(MAGENTA);cprintf(" G");
		textcolor(LIGHTBLUE);cprintf("oto Line");
		textbackground(LIGHTBLUE);textcolor(MAGENTA);
		gotoxy(14,3);cprintf(" F");
		textcolor(WHITE);cprintf("ind     ");
		barno = 1;
	}

}
if (paramenuno==4)
{
	if (paramenubar == 1)
	{
		gotoxy(41,3);
		textbackground(DARKGRAY);
		textcolor(MAGENTA);cprintf(" F");
		textcolor(LIGHTBLUE);cprintf("ile Commands   ");
		textbackground(LIGHTBLUE);textcolor(MAGENTA);
		gotoxy(41,8);cprintf(" M");
		textcolor(WHITE);cprintf("iscellaneous   ");
		barno = 6;
	}

	if (paramenubar == 2)
	{
		gotoxy(41,4);
		textbackground(DARKGRAY);
		textcolor(MAGENTA);cprintf(" S");
		textcolor(LIGHTBLUE);	  cprintf("earch Commands ");
		textbackground(LIGHTBLUE);textcolor(MAGENTA);
		gotoxy(41,3);cprintf(" F");
		textcolor(WHITE);cprintf("ile Commands   ");
		barno = 1;
	}

		if (paramenubar == 3)
	{
		gotoxy(41,5);
		textbackground(DARKGRAY);
		textcolor(MAGENTA);cprintf(" C");
		textcolor(LIGHTBLUE);cprintf("ursor Commands ");
		textbackground(LIGHTBLUE);textcolor(MAGENTA);
		gotoxy(41,4);cprintf(" S");
		textcolor(WHITE);cprintf("earch Commands ");
		barno = 2;
	}

	if (paramenubar == 4)
	{
		gotoxy(41,6);
		textbackground(DARKGRAY);
		textcolor(MAGENTA);cprintf(" I");
		textcolor(LIGHTBLUE);cprintf("nsert Commands ");
		textbackground(LIGHTBLUE);textcolor(MAGENTA);
		gotoxy(41,5);cprintf(" C");
		textcolor(WHITE);cprintf("ursor Commands ");
		barno = 3;
	}

		if (paramenubar == 5)
	{
		gotoxy(41,7);
		textbackground(DARKGRAY);
		textcolor(MAGENTA);cprintf(" D");
		textcolor(LIGHTBLUE);cprintf("elete Commands ");
		textbackground(LIGHTBLUE);textcolor(MAGENTA);
		gotoxy(41,6);cprintf(" I");
		textcolor(WHITE);cprintf("nsert Commands ");
		barno = 4;
	}

	if (paramenubar == 6)
	{
		gotoxy(41,8);
		textbackground(DARKGRAY);
		textcolor(MAGENTA);cprintf(" M");
		textcolor(LIGHTBLUE);cprintf("iscellaneous   ");
		textbackground(LIGHTBLUE);textcolor(MAGENTA);
		gotoxy(41,7);cprintf(" D");
		textcolor(WHITE);cprintf("elete Commands ");
		barno = 5;
	}

	}

			textbackground(DARKGRAY);textcolor(WHITE);

}


/* Moves menu bar down, if menu is activated */
void movebardown(int paramenuno,int paramenubar)

{
if (paramenuno==1)
{
	if (paramenubar == 1)
	{
		gotoxy(2,3);
		textbackground(DARKGRAY);
		textcolor(MAGENTA);cprintf(" N");
		textcolor(LIGHTBLUE);cprintf("ew      ");
		textbackground(LIGHTBLUE);
		textcolor(MAGENTA);gotoxy(2,4);cprintf(" L");
		textcolor(WHITE);cprintf("oad     ");
		barno = 2;
	}

	if (paramenubar == 2)
	{
		gotoxy(2,4);
		textbackground(DARKGRAY);
		textcolor(MAGENTA);
		cprintf(" L");
		textcolor(LIGHTBLUE);cprintf("oad     ");
		textbackground(LIGHTBLUE);
		textcolor(MAGENTA);gotoxy(2,5);
		cprintf(" S");
		textcolor(WHITE);cprintf("ave     ");
		barno = 3;
	}

	if (paramenubar == 3)
	{
		gotoxy(2,5);
		textbackground(DARKGRAY);
		textcolor(MAGENTA);cprintf(" S");
		textcolor(LIGHTBLUE);cprintf("ave     ");
		textbackground(LIGHTBLUE);
		textcolor(MAGENTA);
		gotoxy(2,6);textcolor(WHITE);cprintf(" S ve as  ");
		gotoxy(4,6);textcolor(MAGENTA);cprintf("a");
		barno = 4;
	}

		if (paramenubar == 4)
	{
		gotoxy(2,6);
		textbackground(DARKGRAY);
		textcolor(LIGHTBLUE);
		cprintf(" S ve as  ");
		textcolor(MAGENTA);gotoxy(4,6);cprintf("a");
		textbackground(LIGHTBLUE);
		textcolor(MAGENTA);
		gotoxy(2,7);
		cprintf(" P");
		textcolor(WHITE);cprintf("rint    ");
		barno = 5;
	}

	if (paramenubar == 5)
	{
		gotoxy(2,7);
		textbackground(DARKGRAY);
		textcolor(LIGHTBLUE);
		cprintf("  rint    ");
		textcolor(MAGENTA);gotoxy(2,7);cprintf(" P");
		textbackground(LIGHTBLUE);
		textcolor(WHITE);
		gotoxy(2,8);
		cprintf("  OS Shell");
		textcolor(MAGENTA);gotoxy(2,8);cprintf(" D");
		barno = 6;
	}

	if (paramenubar == 6)
	{
		gotoxy(2,8);
		textbackground(DARKGRAY);
		textcolor(MAGENTA);
		cprintf(" D");
		textcolor(LIGHTBLUE);cprintf("OS Shell");
		textbackground(LIGHTBLUE);
		textcolor(WHITE);
		gotoxy(2,9);
		cprintf(" E it     ");gotoxy(4,9);
		textcolor(MAGENTA);cprintf("x");
		barno = 7;
	}

		if (paramenubar == 7)
	{
		gotoxy(2,9);
		textbackground(DARKGRAY);
		textcolor(LIGHTBLUE);
		cprintf(" E it     ");
		textcolor(MAGENTA);gotoxy(4,9);cprintf("x");
		textbackground(LIGHTBLUE);
		textcolor(MAGENTA);
		gotoxy(2,3);
		cprintf(" N");
		textcolor(WHITE);cprintf("ew      ");
		barno = 1;
	}
}

if (paramenuno==2)
{
	if (paramenubar == 1)
	{
		gotoxy(14,3);
		textbackground(DARKGRAY);
		textcolor(MAGENTA);cprintf(" F");
		textcolor(LIGHTBLUE);cprintf("ind     ");
		textbackground(LIGHTBLUE);textcolor(MAGENTA);
		gotoxy(14,4);cprintf(" G");
		textcolor(WHITE);cprintf("oto Line");
		barno = 2;
	}

	if (paramenubar == 2)
	{
		gotoxy(14,4);
		textbackground(DARKGRAY);
		textcolor(MAGENTA);cprintf(" G");
		textcolor(LIGHTBLUE);cprintf("oto Line");
		textbackground(LIGHTBLUE);textcolor(MAGENTA);
		gotoxy(14,3);cprintf(" F");
		textcolor(WHITE);cprintf("ind     ");
		barno = 1;
	}

}
if (paramenuno==4)
{
	if (paramenubar == 1)
	{
		gotoxy(41,3);
		textbackground(DARKGRAY);
		textcolor(MAGENTA);cprintf(" F");
		textcolor(LIGHTBLUE);cprintf("ile Commands   ");
		textbackground(LIGHTBLUE);textcolor(MAGENTA);
		gotoxy(41,4);cprintf(" S");
		textcolor(WHITE);cprintf("earch Commands ");
		barno = 2;
	}

	if (paramenubar == 2)
	{
		gotoxy(41,4);
		textbackground(DARKGRAY);
		textcolor(MAGENTA);cprintf(" S");
		textcolor(LIGHTBLUE);	  cprintf("earch Commands ");
		textbackground(LIGHTBLUE);textcolor(MAGENTA);
		gotoxy(41,5);cprintf(" C");
		textcolor(WHITE);cprintf("ursor Commands ");
		barno = 3;
	}

		if (paramenubar == 3)
	{
		gotoxy(41,5);
		textbackground(DARKGRAY);
		textcolor(MAGENTA);cprintf(" C");
		textcolor(LIGHTBLUE);cprintf("ursor Commands ");
		textbackground(LIGHTBLUE);textcolor(MAGENTA);
		gotoxy(41,6);cprintf(" I");
		textcolor(WHITE);cprintf("nsert Commands ");
		barno = 4;
	}

	if (paramenubar == 4)
	{
		gotoxy(41,6);
		textbackground(DARKGRAY);
		textcolor(MAGENTA);cprintf(" I");
		textcolor(LIGHTBLUE);cprintf("nsert Commands ");
		textbackground(LIGHTBLUE);textcolor(MAGENTA);
		gotoxy(41,7);cprintf(" D");
		textcolor(WHITE);cprintf("elete Commands ");
		barno = 5;
	}

		if (paramenubar == 5)
	{
		gotoxy(41,7);
		textbackground(DARKGRAY);
		textcolor(MAGENTA);cprintf(" D");
		textcolor(LIGHTBLUE);cprintf("elete Commands ");
		textbackground(LIGHTBLUE);textcolor(MAGENTA);
		gotoxy(41,8);cprintf(" M");
		textcolor(WHITE);cprintf("iscellaneous   ");
		barno = 6;
	}

	if (paramenubar == 6)
	{
		gotoxy(41,8);
		textbackground(DARKGRAY);
		textcolor(MAGENTA);cprintf(" M");
		textcolor(LIGHTBLUE);cprintf("iscellaneous   ");
		textbackground(LIGHTBLUE);textcolor(MAGENTA);
		gotoxy(41,3);cprintf(" F");
		textcolor(WHITE);cprintf("ile Commands   ");
		barno = 1;
	}

	}

			textbackground(DARKGRAY);textcolor(WHITE);

}

/* Creates a new document */
void createnew()
{
	int i;
	textbackground(DARKGRAY);
	textcolor(LIGHTBLUE);
	clrscr();
	drawbox(1,2,80,24);
	gotoxy(63,24);
	textbackground(WHITE);textcolor(MAGENTA);
	gotoxy(2,25);
	cprintf(" F1               F2               F3               F4               F10      ");
	textcolor(BLUE);
	gotoxy(6,25);cprintf("Help");
	gotoxy(23,25);cprintf("Save");
	gotoxy(40,25);cprintf("Load");
	gotoxy(57,25);cprintf("New");
	gotoxy(75,25);cprintf("Menu");
	textbackground(DARKGRAY);
	gotoxy(63,24);
	textcolor(WHITE);
	cprintf("Composer Ver 1.00");
	gotoxy(1,1);
	textcolor(MAGENTA);
	cprintf(" F           S             A            H    ");
	textcolor(WHITE);
	gotoxy(3,1);cprintf("ile");
	gotoxy(15,1);cprintf("earch");
	gotoxy(29,1);cprintf("bout");
	gotoxy(42,1);cprintf("elp");
	ShowCursorPosition();
	menuactivated = 0;
	normal;
	sav=0;
	flag=1;
	filefree();
	ptr=lnew();
	ptr->rptr=NULL;
	ptr->lptr=NULL;
	ptr->info[0]='\0';
	first = ptr;
	l=0;
	row=3;
	col=2;
	fname[0]='N';
	fname[1]='O';
	fname[2]='N';
	fname[3]='A';
	fname[4]='M';
	fname[5]='E';
	fname[6]='\0';
	sav=1;
	ShowCursorPosition();
	textattr(BLACK + WHITE);
	return;

}

/* Prints help on File options*/
void printfilehelp()
{
	char ch;
	helpactivated = 1;
	helplastactivated = 1;
	clearmenu(4);
	RestoreScreenContents();
	SaveScreenContents();
	clearbox(20,10,60,20);
	drawbox(20,10,60,20);
	textcolor(WHITE);
	gotoxy(22,10);cprintf("Help - FILE Commands");
	gotoxy(25,12);printf("Load a file ----------- Alt F L");
	gotoxy(25,13);printf("Open a new file ------- Alt F N");
	gotoxy(25,14);printf("Save and resume ------- Alt F S");
	gotoxy(25,15);printf("Save as --------------- Alt F a");
	gotoxy(25,16);printf("Print a file ---------- Alt F P");
	textbackground(LIGHTBLUE);textcolor(WHITE);
	gotoxy(37,18);cprintf(" Exit ");
	ch=1;
	while ((ch!=27) && (ch!=13))
		ch=getch();
	textbackground(DARKGRAY);
	RestoreScreenContents();
}


/* Prints help on Search options*/
void printsearchhelp()
{
	char ch;
	helpactivated = 1;
	helplastactivated = 2;
	clearmenu(4);
	RestoreScreenContents();
	SaveScreenContents();
	clearbox(20,10,60,20);
	drawbox(20,10,60,20);
	textcolor(WHITE);
	gotoxy(22,10);cprintf("Help - SEARCH Commands");
	gotoxy(25,12);printf("Find Text ------------- Alt S F");
	gotoxy(25,13);printf("Go To line number ----- Alt S G");
	textbackground(LIGHTBLUE);textcolor(WHITE);
	gotoxy(37,18);cprintf(" Exit ");
	ch=1;
	while ((ch!=27) && (ch!=13))
		ch=getch();
	textbackground(DARKGRAY);
	RestoreScreenContents();
}

/* Prints help on delete options*/
void printdeletehelp()
{
	char ch;
	helpactivated = 1;
	helplastactivated = 5;
	clearmenu(4);
	RestoreScreenContents();
	SaveScreenContents();
	clearbox(17,10,66,20);
	drawbox(17,10,66,20);
	textcolor(WHITE);
	gotoxy(19,10);cprintf("Help - DELETE Commands");
	gotoxy(20,12);printf("Delete a line ----------------------- Ctrl Y");
	gotoxy(20,13);printf("Delete character left of cursor -- Backspace");
	gotoxy(20,14);printf("Delete character at cursor ------------- Del");
	textbackground(LIGHTBLUE);textcolor(WHITE);
	gotoxy(37,18);cprintf(" Exit ");
	ch=1;
	while ((ch!=27) && (ch!=13))
		ch=getch();
	textbackground(DARKGRAY);
	RestoreScreenContents();
}


/* Prints help on Insert options */
void printinserthelp()
{
	char ch;
	helpactivated = 1;
	helplastactivated = 4;
	clearmenu(4);
	RestoreScreenContents();
	SaveScreenContents();
	clearbox(20,10,60,20);
	drawbox(20,10,60,20);
	textcolor(WHITE);
	gotoxy(22,10);cprintf("Help - INSERT Commands");
	gotoxy(25,12);printf("Toggle Insert Mode ----- Insert");
	textbackground(LIGHTBLUE);textcolor(WHITE);
	gotoxy(37,18);cprintf(" Exit ");
	ch=1;
	while ((ch!=27) && (ch!=13))
		ch=getch();
	textbackground(DARKGRAY);
	RestoreScreenContents();
}

/* Prints help on miscellaneous options */
void printmischelp()
{
	char ch;
	helpactivated = 1;
	helplastactivated = 6;
	clearmenu(4);
	RestoreScreenContents();
	SaveScreenContents();
	clearbox(19,10,62,20);
	drawbox(19,10,62,20);
	textcolor(WHITE);
	gotoxy(21,10);cprintf("Help - MISCELLANEOUS Commands");
	gotoxy(22,12);printf("Activate Main Menu----------------- F10");
	gotoxy(22,13);printf("Activate Help Screens -------------- F1");
	gotoxy(22,14);printf("Save current file ------------------ F2");
	gotoxy(22,15);printf("Display Product Information - Shift F10");
	gotoxy(22,16);printf("Exit to DOS Prompt -------------- Alt D");
	gotoxy(22,17);printf("Exit from the application ------- Alt x");
	textbackground(LIGHTBLUE);textcolor(WHITE);
	gotoxy(37,19);cprintf(" Exit ");
	ch=1;
	while ((ch!=27) && (ch!=13))
		ch=getch();
	textbackground(DARKGRAY);
	RestoreScreenContents();
}


/* Prints help on Cursor options */
void printcursorhelp()
{
	char ch;
	helpactivated = 1;
	helplastactivated = 3;
	clearmenu(4);
	RestoreScreenContents();
	SaveScreenContents();
	clearbox(17,7,63,23);
	drawbox(17,7,63,23);
	textcolor(WHITE);
	gotoxy(20,7);cprintf("Help - CURSOR Commands");
	gotoxy(21, 9);printf("Character Left --------------Left Arrow");
	gotoxy(21,10);printf("Character Right ----------- Right Arrow");
	gotoxy(21,11);printf("Line Up ---------------------- Up Arrow");
	gotoxy(21,12);printf("Line Down ------------------ Down Arrow");
	gotoxy(21,13);printf("Page Up ------------------------- Pg Up");
	gotoxy(21,14);printf("Page Down --------------------- Pg Down");
	gotoxy(21,15);printf("Beginning of file ---------- Ctrl Pg Up");
	gotoxy(21,16);printf("End of file -------------- Ctrl Pg Down");
	gotoxy(21,17);printf("Top of Screen ----------------Ctrl Home");
	gotoxy(21,18);printf("Bottom of Screen ------------- Ctrl End");
	gotoxy(21,19);printf("Beginning of line ---------------- Home");
	gotoxy(21,20);printf("End of line ----------------------- End");
	textbackground(LIGHTBLUE);textcolor(WHITE);
	gotoxy(37,22);cprintf(" Exit ");
	ch=1;
	while ((ch!=27) && (ch!=13))
		ch=getch();
	textbackground(DARKGRAY);
	RestoreScreenContents();
}

/* Prints details About Composer 1.00 */
void printabout()
{
	char ch;
	clearmenu(3);
	SaveScreenContents();
	clearbox(19,10,62,21);
	drawbox(19,10,62,21);
	textcolor(WHITE);
	gotoxy(21,10);cprintf("ABOUT Composer Ver 1.00");
	gotoxy(22,12);printf("This application was designed and exec-");
	gotoxy(22,13);printf("uted by Sudarshan Baily of the III Sem-");
	gotoxy(22,14);printf("ester MCA, Christ  College as part  of ");
	gotoxy(22,15);printf("Bangalore University's requirements for");
	gotoxy(22,16);printf("the MCA Programme. Comments/Suggestions");
	gotoxy(22,17);printf("may be sent to sudsbaily007@yahoo.com  ");
	gotoxy(22,18);printf("Licensed to Christ College, Bangalore. ");
	textbackground(LIGHTBLUE);textcolor(WHITE);
	gotoxy(37,20);cprintf(" Exit ");
	ch=1;
	while ((ch!=27) && (ch!=13))
		ch=getch();
	textbackground(DARKGRAY);
	RestoreScreenContents();
}


/* Function to load a file */
void OpenFileDialogBox()
{
	FILE *fptr;
	int option =1 ;
	int ch;
	char tempfname[40];
	clearmenu(1);
	menuactivated=0;
	menupadactivated=0;
	RestoreScreenContents();
	SaveScreenContents();
	clearbox(20,10,60,20);
	drawbox(20,10,60,20);
	textcolor(WHITE);
	gotoxy(33,10);cprintf("Open File");
	gotoxy(22,12);printf("Open File");
	textbackground(LIGHTBLUE);
	for (i=22;i<=58;i++) {gotoxy(i,13);cprintf(" ");}
	textbackground(LIGHTBLUE);textcolor(WHITE);
	gotoxy(30,18);cprintf(" Open ");
	textbackground(DARKGRAY);textcolor(WHITE);
	gotoxy(45,18);cprintf(" Cancel ");
	gotoxy(22,13);gets(tempfname);
	gotoxy(30,18);
	GetText: GetKey();
	if ((Scan!=LEFT) && (Scan!=RIGHT) && (Ascii!=TAB) && (Ascii!=ENTER)) goto GetText;
	if (((Scan == LEFT) || (Scan == RIGHT) || (Ascii == TAB)) && (option ==1))
	{
		textbackground(DARKGRAY);textcolor(WHITE);
		gotoxy(30,18);cprintf (" Open ");
		textbackground(LIGHTBLUE);textcolor(WHITE);
		gotoxy(45,18);cprintf (" Cancel ");
		option = 2;
		gotoxy(45,18);
		goto GetText;
	}

	if (((Scan == LEFT) || (Scan == RIGHT) || (Ascii == TAB)) && (option ==2))
	{
		textbackground(LIGHTBLUE);textcolor(WHITE);
		gotoxy(30,18);cprintf (" Open ");
		textbackground(DARKGRAY);textcolor(WHITE);
		gotoxy(45,18);cprintf (" Cancel ");
		option = 1;
		gotoxy(30,18);
		goto GetText;
	}

	if ((Ascii == ENTER ) && (option ==2))
	{
		textbackground(DARKGRAY);
		RestoreScreenContents();
                Ascii=27;
		return;
	}

	if ((Ascii == ENTER ) && (option ==1)) /* Load fn to be called here*/
	{
	puttext(1,1,80,25,buffer);
	fptr=fopen(tempfname,"r");
	if (fptr==NULL)
	{
		SaveScreenContents();
		clearbox(20,7,60,11);
		drawbox(20,7,60,11);
		gotoxy(28,9);
		textcolor(WHITE);
		cprintf("Unable to open file.....");
		getch();
		RestoreScreenContents();
                Ascii=27;
		return;
	}
	strcpy(fname,tempfname);
	createnew();
	sav=1;
	strcpy(fname,tempfname);
	ShowCursorPosition();
	nptr=lnew();
	nptr->rptr=NULL;
	nptr->lptr = NULL;
	nptr->info[0]='\0';
	first=nptr;
	ptr=first;
	i=0;
	while (!feof(fptr))
	{
		c=fgetc(fptr);
		if ((i>=78) || (c=='\n') || (c=='\0'))
		{
			ptr->info[i]='\0';
			nptr=lnew();
			nptr->lptr=ptr;
			ptr->rptr=nptr;
			nptr->rptr=NULL;
			nptr->info[0]='\0';
			ptr=nptr;
			i=0;
		}
		else
			if (c!='\t')
				ptr->info[i++]=c;
		else
			for (k=0;k<8 && i<79;k++)
				ptr->info[i++]=' ';
	}
	ptr=ptr->lptr;
	ptr->rptr=NULL;
	gotoxy(2,3);
	for (k=1,ptr=first;((ptr!=NULL) && (k<22));k++,ptr=ptr->rptr)
	{
		gotoxy(2,wherey());
		textcolor(WHITE);
		for (i=0;i<79 && ptr->info[i]!='\0';i++)
			cprintf("%c",ptr->info[i]);
		printf("\n");
	}
	ptr=first;
	Ins=1;
	fclose(fptr);
	return;
}
}

/* Function to handle the first save of the document */
void initsave()
{
		FILE *fptr;
		fptr = fopen(filename,"w");
		if (fptr == NULL)
		{
			SaveScreenContents();
			drawbox(20,6,60,10);
			gotoxy(28,8);
			textcolor(WHITE);
			cprintf("Unable to open file.....");
			getch();
			RestoreScreenContents();
                	Ascii=27;
			return;
		}
		strcpy(fname,filename);
		SaveScreenContents();
		for (tp=first;tp!=NULL;tp=tp->rptr)
		{
			for(i=0;tp->info[i]!='\0';i++)
				{
					cha = tp->info[i];
					putc(cha,fptr);
				}
			fputc('\n',fptr);
		}
		RestoreScreenContents();
		fclose(fptr);
		col=2;
		flag=1;sav=1;
		return;
	}


/* Function to handle the first load of a document */
void initload()
{	FILE *fptr;
	fptr=fopen(filename,"r");
	if (fptr==NULL)
	{
		initsave();
		return;
	}
	createnew();
	sav=1;
//	strcpy(fname,tempfname);
	ShowCursorPosition();
	nptr=lnew();
	nptr->rptr=NULL;
	nptr->lptr = NULL;
	nptr->info[0]='\0';
	first=nptr;
	ptr=first;
	i=0;
	while (!feof(fptr))
	{
		c=fgetc(fptr);
		if ((i>=78) || (c=='\n') || (c=='\0'))
		{
			ptr->info[i]='\0';
			nptr=lnew();
			nptr->lptr=ptr;
			ptr->rptr=nptr;
			nptr->rptr=NULL;
			nptr->info[0]='\0';
			ptr=nptr;
			i=0;
		}
		else
			if (c!='\t')
				ptr->info[i++]=c;
		else
			for (k=0;k<8 && i<79;k++)
				ptr->info[i++]=' ';
	}
	ptr=ptr->lptr;
	ptr->rptr=NULL;
	gotoxy(2,3);
	for (k=1,ptr=first;((ptr!=NULL) && (k<22));k++,ptr=ptr->rptr)
	{
		gotoxy(2,wherey());
		textcolor(WHITE);
		for (i=0;i<79 && ptr->info[i]!='\0';i++)
			cprintf("%c",ptr->info[i]);
		printf("\n");
	}
	ptr=first;
	Ins=1;
	fclose(fptr);
	return;
}

/* Function to find a string in the document */
void FindFn()
{
	int CtrVar=1;
	int Flag=0;
	ctr_pgup();
	for (tp1=first;tp1!=NULL;tp1=tp1->rptr,CtrVar++)
		{
			FoundPtr = strstr(tp1->info,SearchStr);
			if (FoundPtr!=NULL)
				{
				Flag=1;
				gettext(1,1,80,25,buffer);
				clearbox(10,6,70,11);
				drawbox(10,6,70,11);
				gotoxy(16,8);
				textcolor(WHITE);
				cprintf("      Search String found on Line Number %d      ",CtrVar);
				gotoxy(16,9);
				cprintf("        Press any key to continue .............    ");
				getch();
				RestoreScreenContents();

				}


		}

			if (Flag == 0)
				{
				gettext(1,1,80,25,buffer);
				clearbox(10,6,70,11);
				drawbox(10,6,70,11);
				gotoxy(16,8);
				textcolor(WHITE);
				cprintf("       Search String not found in document        ");
				gotoxy(16,9);
				cprintf("        Press any key to continue .............    ");
				getch();
				if (Scan == RIGHT) getch();
				fflush(stdin);
				puttext(1,1,80,25,buffer);
				}

			RestoreScreenContents();

}

/* Function to display the Find dialog box*/
void FindDialogBox()
{
	int option = 1 ;
	char fname[10];
	char ch1,ch2;
	clearmenu(2);
	RestoreScreenContents();
	SaveScreenContents();
	clearbox(20,10,61,20);
	drawbox(20,10,61,20);
	textcolor(WHITE);
	gotoxy(34,10);cprintf("Find Text");
	gotoxy(22,12);printf("Text to find");
	textbackground(LIGHTBLUE);
	for (i=22;i<=59;i++) {gotoxy(i,13);cprintf(" ");}
	textbackground(LIGHTBLUE);textcolor(WHITE);
	gotoxy(30,18);cprintf(" Find ");
	textbackground(DARKGRAY);textcolor(WHITE);
	gotoxy(45,18);cprintf(" Cancel ");
	gotoxy(22,13);gets(SearchStr);
	gotoxy(30,18);
	GetText: GetKey();
	if (((Scan == LEFT) || (Scan == RIGHT) || (Ascii == TAB)) && (option ==1))
	{
		textbackground(DARKGRAY);textcolor(WHITE);
		gotoxy(30,18);cprintf (" Find ");
		textbackground(LIGHTBLUE);textcolor(WHITE);
		gotoxy(45,18);cprintf (" Cancel ");
		option = 2;
		gotoxy(45,18);
		goto GetText;
	}

	if (((Scan == LEFT) || (Scan == RIGHT) || (Ascii == TAB)) && (option ==2))
	{
		textbackground(LIGHTBLUE);textcolor(WHITE);
		gotoxy(30,18);cprintf (" Find ");
		textbackground(DARKGRAY);textcolor(WHITE);
		gotoxy(45,18);cprintf (" Cancel ");
		option = 1;
		gotoxy(30,18);
		goto GetText;
	}

	if ((Ascii == ENTER ) && (option ==2))
	{
		textbackground(DARKGRAY);
		RestoreScreenContents();
                Ascii=27;
		return;
	}

	if ((Ascii == ENTER ) && (option ==1)) /* Find fn to be called here*/
	{
		RestoreScreenContents();
		textbackground(DARKGRAY);
		FindFn();
		RestoreScreenContents();
                Ascii=27;
		return;
	}

	textbackground(DARKGRAY);
	RestoreScreenContents();
}

/* Function to go to a particular line */
void GotoLine()

{       int CtrVar=0;
	int LineNo;
	int option;
	// First find how many lines of text are in document//
	first:CtrVar=0;
	for (tp1=first;tp1!=NULL;tp1=tp1->rptr)
	{CtrVar++;}

	clearmenu(2);
	RestoreScreenContents();
	SaveScreenContents();
	clearbox(20,10,61,20);
	drawbox(20,10,61,20);
	textcolor(WHITE);
	gotoxy(34,10);cprintf("Go To Line Number");
	gotoxy(22,12);printf("Enter new line number : ");
	textbackground(LIGHTBLUE);
	for (i=46;i<=59;i++) {gotoxy(i,12);cprintf(" ");}
	textbackground(LIGHTBLUE);textcolor(WHITE);
	gotoxy(30,18);cprintf(" OK ");
	textbackground(DARKGRAY);textcolor(WHITE);
	gotoxy(45,18);cprintf(" Cancel ");
	gotoxy(47,12);scanf("%d",&LineNo);
	gotoxy(30,18);
	GetText: GetKey();
	if ((Scan!=LEFT) && (Scan!=RIGHT) && (Ascii!=TAB) && (Ascii!=ENTER)) goto GetText;
	if (((Scan == LEFT) || (Scan == RIGHT) || (Ascii == TAB)) && (option ==1))
	{
		textbackground(DARKGRAY);textcolor(WHITE);
		gotoxy(30,18);cprintf (" OK ");
		textbackground(LIGHTBLUE);textcolor(WHITE);
		gotoxy(45,18);cprintf (" Cancel ");
		option = 2;
		gotoxy(45,18);
		goto GetText;
	}

	if (((Scan == LEFT) || (Scan == RIGHT) || (Ascii == TAB)) && (option ==2))
	{
		textbackground(LIGHTBLUE);textcolor(WHITE);
		gotoxy(30,18);cprintf (" OK ");
		textbackground(DARKGRAY);textcolor(WHITE);
		gotoxy(45,18);cprintf (" Cancel ");
		option = 1;
		gotoxy(30,18);
		goto GetText;
	}

	if ((Ascii == ENTER ) && (option ==2))
	{
		textbackground(DARKGRAY);
		RestoreScreenContents();
                Ascii=27;
		return;
	}

	if ((Ascii == ENTER ) && (option ==1)) /* Actual Action takes place here */
	{
		if ((LineNo<1) || (LineNo>CtrVar))
		{
		clearbox(20,10,61,20);
		drawbox(20,10,61,20);
		textcolor(WHITE);
		gotoxy(34,10);cprintf("Error Message");
		gotoxy(22,12);printf("Line Number not within valid range... ");
		gotoxy(22,14);printf("Valid Range is from 1 to %d",CtrVar);
		textbackground(LIGHTBLUE);
		gotoxy(38,18);cprintf(" OK ");
		getch();
		goto first;
		}

		else
		{
			RestoreScreenContents();
			home();
			ctr_pgup();
			CtrVar=1;
			while (CtrVar<LineNo) {linedn();CtrVar++;}
		}
                Ascii=27;
		return;
	}

}

/* Function to produce a hard copy of a document*/
void printfile()
{
	int i,len;
	clearmenu(1);
	RestoreScreenContents();
	SaveScreenContents();
	clearbox(20,10,60,15);
	drawbox(20,10,60,15);
	gotoxy(27,12);textcolor(WHITE);
	cprintf("Preparing to print file...");
	getch();
	RestoreScreenContents();

	for (tp=first;tp!=NULL;tp=tp->rptr)
	{
		for (i=0;i<79  && tp->info[i]!='\0';i++)
		{
			fputc(tp->info[i],stdprn);
		}
		fputc('\n',stdprn);
	}
}

/* Decides what action to take, based on users choice */
void selectoption(int paramenuno, int parabarno)
{
	menuactivated = 0; menupadactivated =0;

	if ((paramenuno == 1) && (parabarno == 1))
	{clearmenu(1);RestoreScreenContents();checksave();createnew();}

	if ((paramenuno == 1) && (parabarno == 2))
	{clearmenu(1);RestoreScreenContents();checksave();OpenFileDialogBox();}

	if ((paramenuno == 1) && (parabarno == 3)) filesave();
	if ((paramenuno == 1) && (parabarno == 4)) SaveAsDialogBox();
	if ((paramenuno == 1) && (parabarno == 5)) printfile();
	if ((paramenuno == 1) && (parabarno == 6))
		{clearmenu(1);SaveScreenContents();shell();RestoreScreenContents();}
	if ((paramenuno == 1) && (parabarno == 7))
	{clearmenu(1);checksave();clrscr();exit(0);}

	if ((paramenuno == 2) && (parabarno == 1)) FindDialogBox();
	if ((paramenuno == 2) && (parabarno == 2)) GotoLine();

	if ((paramenuno == 3) && (parabarno == 1)) printabout();

	if ((paramenuno == 4) && (parabarno == 1)) printfilehelp();
	if ((paramenuno == 4) && (parabarno == 2)) printsearchhelp();
	if ((paramenuno == 4) && (parabarno == 3)) printcursorhelp();
	if ((paramenuno == 4) && (parabarno == 4)) printinserthelp();
	if ((paramenuno == 4) && (parabarno == 5)) printdeletehelp();
	if ((paramenuno == 4) && (parabarno == 6)) printmischelp();

	textbackground(DARKGRAY);textcolor(WHITE);
}

/* Indicates what action to take based on menu invoked, and hotkey pressed*/
void MenuOperation()
{
	if (((Ascii == BIGN) || (Ascii == SMALLN)) && (menuno == 1))
		{clearmenu(menuno);barno=1;menuno=1;selectoption(menuno,barno);}
	else
		if (((Ascii == BIGL) || (Ascii == SMALLL)) && (menuno == 1))
		{clearmenu(menuno);barno=2;menuno=1;selectoption(menuno,barno);}
	else
		if (((Ascii == BIGS) || (Ascii == SMALLS)) && (menuno == 1))
		{clearmenu(menuno);barno=3;menuno=1;selectoption(menuno,barno);}
	else
		if (((Ascii == BIGA) || (Ascii == SMALLA)) && (menuno == 1))
		{clearmenu(menuno);barno=4;menuno=1;selectoption(menuno,barno);}
	else
		if (((Ascii == BIGP) || (Ascii == SMALLP)) && (menuno == 1))
		{clearmenu(menuno);barno=5;menuno=1;selectoption(menuno,barno);}
	else
		if (((Ascii == BIGD) || (Ascii == SMALLD)) && (menuno == 1))
		{clearmenu(menuno);barno=6;menuno=1;selectoption(menuno,barno);}
	else
		if (((Ascii == BIGX) || (Ascii == SMALLX)) && (menuno == 1))
		{clearmenu(1);checksave();exit(0);}
	else
		if (((Ascii == BIGF) || (Ascii == SMALLF)) && (menuno == 2))
		{clearmenu(menuno);barno=1;menuno=2;selectoption(menuno,barno);}
	else
		if (((Ascii == BIGG) || (Ascii == SMALLG)) && (menuno == 2))
		{clearmenu(menuno);barno=2;menuno=2;selectoption(menuno,barno);}
	else
		if (((Ascii == BIGF) || (Ascii == SMALLF)) && (menuno == 4))
		{clearmenu(menuno);barno=1;menuno=4;selectoption(menuno,barno);}
	else
		if (((Ascii == BIGS) || (Ascii == SMALLS)) && (menuno == 4))
		{clearmenu(menuno);barno=2;menuno=4;selectoption(menuno,barno);}
	else
		if (((Ascii == BIGC) || (Ascii == SMALLC)) && (menuno == 4))
		{clearmenu(menuno);barno=3;menuno=4;selectoption(menuno,barno);}
	else
		if (((Ascii == BIGI) || (Ascii == SMALLI)) && (menuno == 4))
		{clearmenu(menuno);barno=4;menuno=4;selectoption(menuno,barno);}
	else
		if (((Ascii == BIGM) || (Ascii == SMALLM)) && (menuno == 4))
		{clearmenu(menuno);barno=6;menuno=4;selectoption(menuno,barno);}
	else
		if (((Ascii == BIGD) || (Ascii == SMALLD)) && (menuno == 4))
		{clearmenu(menuno);barno=5;menuno=4;selectoption(menuno,barno);}
	else
	if (Scan == ALTF)

		{clearmenu(menuno);printfilemenu();}
	else
		if (Scan == ALTS)
		{clearmenu(menuno);printsearchmenu();}
	else
		if (Scan == ALTA)
		{clearmenu(menuno);printaboutmenu();}
	else
		if (Scan == ALTH)
		{clearmenu(menuno);printhelpmenu();}
	else
		if (Scan == RIGHT)
		{
			clearmenu(menuno);
			menuno++;
			if (menuno > 4) menuno=1;
			if (menuno==1) {printfilemenu();barno =1;}
			if (menuno==2) {printsearchmenu();barno =1;}
			if (menuno==3) {printaboutmenu();barno =1;}
			if (menuno==4) {printhelpmenu();barno =1;}
		}

		if (Scan == LEFT)
		{
			clearmenu(menuno);
			menuno--;
			if (menuno < 1) menuno=4;
			if (menuno==1) {printfilemenu();barno =1;}
			if (menuno==2) {printsearchmenu();barno =1;}
			if (menuno==3) {printaboutmenu();barno =1;}
			if (menuno==4) {printhelpmenu();barno =1;}
		}
		else
		if (Scan == DOWN) {movebardown(menuno,barno);}
		else
		if (Scan == UP) {movebarup(menuno,barno);}
		else
		if (Ascii == ENTER) {selectoption(menuno,barno);}
		else
		if
		(Ascii == ESC) {clearmenu(menuno);}
	}

/* Clears the pad when no longer activated */
void clearpad()
{
	gotoxy(1,1);textcolor(MAGENTA);
	cprintf(" F           S             A            H    ");
	textcolor(WHITE);
	gotoxy(3,1);cprintf("ile");
	gotoxy(15,1);cprintf("earch");
	gotoxy(29,1);cprintf("bout");
	gotoxy(42,1);cprintf("elp");
}


/* Performs operations on menu bar when activated */
void PadOperation()
{

	if (Scan == ALTF) {clearpad();printfilemenu();}

	if (Scan == ALTS) {clearpad();printsearchmenu();}

	if (Scan == ALTA) {clearpad();printaboutmenu();}

	if (Scan == ALTH){clearpad();printhelpmenu();}

	if ((Scan == RIGHT) && (menupadactivated == 1))
	{
		menupadno++;
		if (menupadno>4) menupadno=1;
		activatepad(menupadno);
	}
	else
	if ((Scan == LEFT) && (menupadactivated == 1))
	{
		menupadno--;
		if (menupadno<1) menupadno=4;
		activatepad(menupadno);
	}
	else
	if (((Scan == DOWN) || (Ascii ==ENTER)) && (menupadactivated ==1) && (menuactivated == 0))
	{
		if (menupadno == 1) printfilemenu();
		if (menupadno == 2) printsearchmenu();
		if (menupadno == 3) printaboutmenu();
		if (menupadno == 4) printhelpmenu();
	}
	else
	if ((Ascii == ESC) && (menupadactivated == 1)) {clearpad();menupadactivated=0;}
	else
	if ((Ascii == BIGF) || (Ascii == SMALLF)) {menupadno =1;clearpad();printfilemenu();}
	else
	if ((Ascii == BIGS) || (Ascii == SMALLS)) {menupadno =2;clearpad();printsearchmenu();}
	else
	if ((Ascii == BIGA) || (Ascii == SMALLA)) {menupadno =3;clearpad();printaboutmenu();}
	else
	if ((Ascii == BIGH) || (Ascii == SMALLH)) {menupadno =4;clearpad();printhelpmenu();}
}

/* Stores a character into the linked list */
void charin(char arr[])
{
	int ccol = col-2;
	sav=0;
	if (ccol>=78)
	{
		column();col=77;
		return;
	}
	for (i=0;arr[i]!='\0';i++);
	if (i<ccol)
	{
		arr[i-1]=' ';
		for (j=i;j<ccol;j++)
			arr[j]=' ';
		arr[ccol]=Ascii;
		arr[ccol+1]='\0';
		return;
	}

	if (Ins == 1)
	{
		for(;i>=ccol && i<78;i--)
			arr[i+1]=arr[i];
		arr[ccol]=Ascii;
		blankline();
		ccol=col-2;
		gotoxy(col,row);textcolor(WHITE);
		for (i=col-2;arr[i]!='\0' && ccol<78;i++,ccol++)
			cprintf("%c",ptr->info[i]);
	}
	else
	{
		if (arr[ccol]=='\0')
		{
			arr[ccol]=Ascii;
			arr[ccol+1]='\0';
		}
		else
		arr[ccol]=Ascii;
	}
	return;
}

/* Takes care of operations when the Enter key is pressed */
void enter()
{
	int i,j=0;
	nptr=lnew();
	nptr->lptr=nptr->rptr=NULL;
	for(i=0;i<79;i++)
		nptr->info[i]='\0';
	nptr->lptr=ptr;
	if (first == NULL)
	{
		first = nptr;
		return;
	}
	flag=0;
	i=col-2;
	if((ptr->rptr)==NULL)
	{
		while(ptr->info[i]!='\0')     /* x0*/
		{
			nptr->info[j]=ptr->info[i];
			ptr->info[i]=' ';
			printch(' ',i+1,row-2);
			i++;j++;
		}
		col=2;
		row++;
		if (row>=24) {row--;sc_up();}
		for (i=0;ptr->info[i]!='\0';i++)
		{       textcolor(WHITE);
			printch(nptr->info[i],col-1,row-2);
			col++;
		}
		col=2;
		gotoxy(col,row);
		nptr->rptr=NULL;
	}
	else
	{
		nptr->rptr=ptr->rptr;
		ptr->rptr->lptr=nptr;
		nptr->lptr=ptr;
		ptr->rptr=nptr;
		if (row<23)
				ensc_dn(row,1,22,77);
		else
				{ensc_up(2,1,22,77);row=23;}
		while (ptr->info[i]!='\0')
		{
			nptr->info[j]=ptr->info[i];
			ptr->info[i]=' ';
			printch(' ',i+1,row-2);
			i++;
			j++;
		}
		col=2;
		row++;
		for (i=0;ptr->info[i]!='\0';i++)
		{
			printch(nptr->info[i],col-1,row-2);
			col++;
		}
		col=2;
		gotoxy(col,row);
		ptr=nptr;
		col=2;
		gotoxy(col,row);
		return;
	}
	ptr->rptr=nptr;
	ptr=nptr;
	col=2;
	gotoxy(col,row);
	return;
}

/* Deletes a character using the Del key */
void delch(char arr[])
{
	int ccol=col-2;
	flag=0;
	if ((col==2) && (ptr->info[0]=='\0') && (ptr->rptr!=NULL))
	{
		linedele();return;
	}
	for (i=ccol;arr[i]!='\0';i++)
		arr[i]=arr[i+1];
		arr[i]='\0';
		blankline();
		gotoxy(2,row);textcolor(WHITE);
		for(i=0;arr[i]!='\0';i++)
			cprintf("%c",arr[i]);
		gotoxy(col,row);
		return;
}

/* Takes care of operations when Backspace is pressed */
void backspace()
{
	int ccol=col-2;

	if ((ccol<=0) && (row==3)) return;

	if (ccol>0)
	{
		gotoxy(8,24);
		printf("%d",ccol);
		gotoxy(ccol+1,row);
	}
	else
	{
		ptr=ptr->lptr;
		home();end();right();
		ccol=col-2;
		gotoxy(8,24);
		printf("%d",ccol);
		gotoxy(ccol+1,row);
		row--;

	}
	printch(' ',ccol,row-2);
	ptr->info[ccol-1]=' ';
	col--;
	drawbox(1,2,80,24);
	return;

}

/* Moves the cursor a page up*/
void page_up()
{
	for (k=0;k<21;k++) lineup();
}

/* Moves the cursor a page down*/
void page_down()
{
	for (k=0;k<21;k++) linedn();
}

void TabFn()
{
	int limit,i,col1;
	col1=col-1;
	if ((col1>=1) && (col1<=8)) limit = 9;
	if ((col1>=9) && (col1<=16)) limit = 17;
	if ((col1>=17) && (col1<=24)) limit = 25;
	if ((col1>=25) && (col1<=32)) limit = 33;
	if ((col1>=33) && (col1<=40)) limit = 41;
	if ((col1>=41) && (col1<=48)) limit = 49;
	if ((col1>=49) && (col1<=56)) limit = 57;
	if ((col1>=57) && (col1<=64)) limit = 65;
	if ((col1>=65) && (col1<=72)) limit = 73;
	if (col1>=73) return;
	Ascii=32;
	Scan = 0;
	for (i=col1;i<limit;i++)
	{
		charin(ptr->info);
	}
	col=limit+1;
	return;
}

/* The main loop of the editor is here ...*/
main(int argc, char *argv[])
{
	clrscr();
   sav=0;
	textattr(BLACK + WHITE);
	_setcursortype(_NORMALCURSOR);
	createnew();
	/* If the number of command line arguments is > 2, terminate*/
	if (argc>2)
	{
		SaveScreenContents();
		clearbox(20,7,60,11);
		drawbox(20,7,60,11);
		gotoxy(24,9);
		textcolor(WHITE);
		cprintf("Invalid number of parameters....");
		fflush(stdin);
		getch();
		exit(0);
	}

	/* If 2 arguments are given, either create the file or load the file*/
	/* according as the file exists or not...*/

	if (argc==2)
	{
		strncpy(filename,argv[1],40);
		initload();
	}


	/* Infinite loop of Editor */
	for(;;)
	{
		ShowCursorPosition();
		textattr(BLACK + WHITE);
		gotoxy(col,row);
		textattr(BLACK + WHITE);
		GetKey();

		if (menuactivated == 1) MenuOperation();
		else
		if (menupadactivated == 1) PadOperation();
		else
		if (Ascii == 0)
		{
			switch(Scan)
			{
				case ALTF:{printfilemenu();break;}

				case ALTS:{printsearchmenu();break;}

				case ALTA:{printaboutmenu();break;}

				case ALTH:{printhelpmenu();break;}

		case F1:
		{
			SaveScreenContents();
			if (helplastactivated == 1) printfilehelp();
			if (helplastactivated == 2) printsearchhelp();
			if (helplastactivated == 3) printcursorhelp();
			if (helplastactivated == 4) printinserthelp();
			if (helplastactivated == 5) printdeletehelp();
			if (helplastactivated == 6) printmischelp();
			RestoreScreenContents();
			break;
		}

		case F2: {filesave();break;}

		case F3: {OpenFileDialogBox();break;}

		case F4: {checksave();createnew();break;}

		case F10: {activatepad(menupadno);break;}

		case SHIFTF10: {printabout();break;}

		case HOME: {home();break;}

		case END: {if (first == NULL) break;
					end();break;}

		case UP:  {lineup();break;}

		case DOWN: {linedn();break;}

		case LEFT: {left();break;}

		case RIGHT: {right();break;}

		case PGUP: {page_up();break;}

		case PGDOWN: {page_down();break;}

		case INS: {Ins=abs(1-Ins);
			   if (Ins == 0)
				{_setcursortype(_SOLIDCURSOR);}
			   else
				{_setcursortype(_NORMALCURSOR);}
				break;
			   }

		case DEL: {sav=0;if (first == NULL) break;
					delch(ptr->info);break;}

		case CTRLEND: {ctr_end();break;}

		case CTRLPGDN: {ctr_pgdn();break;}

		case CTRLHOME: {ctr_home();break;}

		case CTRLPGUP: {ctr_pgup();break;}

		case ALTX: {checksave();clrscr();exit(0);}
	}
  }

  else
		switch (Ascii)
		{
			case BKSPACE: {sav=0;if (first == NULL) break;
							backspace();break;}

			case ENTER: {sav=0;enter();break;}

			case CTRLY: {sav=0;linedele();break;}

			case ESC : break;

			case TAB : {TabFn();break;}

			default:	if ((isprint(toascii(Ascii))) && ((Ascii>=32) && (Ascii<=126)))
						{
							if (col>79)
							{
								column();break;
							}

							if (first == NULL)
							{
								nptr=lnew();
								nptr->rptr=NULL;
								nptr->lptr=NULL;
								nptr->info[0]='\0';
								first=nptr;
								ptr=nptr;
							}

							charin(ptr->info);
							gotoxy(col++,row);textattr(BLACK + WHITE);
							cprintf("%c",Ascii);
							flag=0;sav=0;
						}
			}
		}
  }
