/* My record 120 moves
This program version 1.0 was originally written on 11-1-2001
In Bangalore,Karnataka,INDIA
Updated to version 3.0 on 17-11-2003 with a new algorithm for displaying movements & status
which works with much lesser steps
Updated to version 4.0 on 17-1-2004 with score board of top 15 movers
Any Query about My projects  or C programming
can be sent to avsharath@yahoo.com or c-ool-Blore@yahoogroups.com */
#include"conio.h"
#include"stdlib.h"
#include"stdio.h"
struct record
{
int moves;
char name[30];
}Toppers[15];

int main()
{
char ch;
int i,j,moves=0;
int correct_pos=0;
int a[4][4]={1,4,15,7,8,10,2,11,14,3,6,13,12,9,5,0},r=3,c=3,r1,c1;
FILE *fp;
fp=fopen("toppers.scr","rb");
if(fp==NULL)//create a dummy score file if score file doesnt exist.
	{
	 fp=fopen("toppers.scr","wb");
	 for(i=0;i<15;i++)
		{
		sprintf(Toppers[i].name,"Anonymous");
		Toppers[i].moves=(i+1)*100;
		}
	fwrite(&Toppers,sizeof(struct record),15,fp);
	fclose(fp);
	}
else
fclose(fp);
highvideo();
_setcursortype(_NOCURSOR);
textbackground(6);
clrscr();
printf("Written by A.V.Sharath\navsharath@yahoo.com");
gotoxy(25,10);
printf("Welcome To The Number Game!\n\n\t\t\t Hit any key to start...");
getch();
clrscr();
gotoxy(16,7); printf("ͻ");
gotoxy(16,8); printf("                                    ");
gotoxy(16,9); printf("͹");
gotoxy(16,10);printf("                                    ");
gotoxy(16,11);printf("͹");
gotoxy(16,12);printf("                                    ");
gotoxy(16,13);printf("͹");
gotoxy(16,14);printf("                                    ");
gotoxy(16,15);printf("ͼ");
gotoxy(32,25);printf(" Hit End key To Quit");
gotoxy(30,18); printf("Total moves: 0");
gotoxy(30,20);
for(i=0;i<4;i++)//display the values
for(j=0;j<4;j++)
	{
	gotoxy( (j+2)*10,(i+4)*2);
	if(a[i][j])
	printf("%2d",a[i][j]);
	if(a[i][j]==(i*4)+j+1)
		correct_pos++;
	}
gotoxy(30,20);
printf("Correct Positions:%2d",correct_pos);

while(ch!=79)/*79 is the value of END key.*/
	{
	r1=c1=0;
	ch=getch();
	if(ch==72&&r<3)r1++;/*down  arrow*/
	if(ch==80&&r>0)r1--;/*up    arrow*/
	if(ch==75&&c<3)c1++;/*right arrow*/
	if(ch==77&&c>0)c1--;/*left  arrow*/
	if((r1+c1)!=0)/*if a legal move is made*/
		{
		moves++;/*increase the total moves*/
		a[r][c]=a[r+r1][c+c1];//change value
		gotoxy( (c+2)*10,(r+4)*2);//print the changed values
		printf("%2d",a[r][c]);

		if(a[r][c]==r*4+c+1)//if the number occupied in new space is the correct number
			correct_pos++;
		r+=r1;c+=c1;
		a[r][c]=0;

		if(a[r-r1][c-c1]==r*4+c+1)//if the number in old place was in correct position
			correct_pos--;
		gotoxy( (c+2)*10,(r+4)*2);
		printf("  ");
		gotoxy(42,18);
		printf("%2d",moves);
		gotoxy(48,20);
		printf("%2d",correct_pos);
		if(correct_pos==15)/*all the numbers are in correct positon*/
			{
			gotoxy(25,17);
			printf("Congrats! You Finished in %d Moves",moves);
			getch();
			display_record(moves);
			exit(0);
			}
		}
	}
return 0;
}

display_record(int moves)
{
FILE *fp;
int i,j;
fp=fopen("toppers.scr","rb");
fread(&Toppers,sizeof(struct record),15,fp);
for(i=0;i<15;i++)
	{
	if(Toppers[i].moves>moves)
		{
		clrscr();
		for(j=14;j>i;j--)//moving all the old records one position back from the new record
			{
			sprintf(Toppers[j].name,Toppers[j-1].name);
			Toppers[j].moves=Toppers[j-1].moves;
			}
		_setcursortype(_NORMALCURSOR);
		printf("You Achieved Place %d Among Top 15 Minimum Movers!",i+1);
		printf("\n\n\n\tEnter your name:");
		scanf("%s",Toppers[i].name);
		Toppers[i].moves=moves;
		break;
		}
	}

fclose(fp);//close the old file
fp=fopen("toppers.scr","wb");//open to write the new record file
fwrite(&Toppers,sizeof(struct record),15,fp);
fclose(fp);
clrscr();
fp=fopen("toppers.scr","rb");
printf("\t\t\tThe Top 15 Movers:\n\n");
printf("\tPlace\t\tPlayer Name\t\tMoves\n\n");
fread(&Toppers,sizeof(struct record),15,fp);//open file to Display The records

for(i=0;i<15;i++)
	{
	printf("\t%2d\t%20s\t\t%d\n",i+1,Toppers[i].name,Toppers[i].moves);
	}
getch();
}









