void drawbmp(char*,int,int);
class vbitmaps
{
public:
void *car[3];
void *jeep[3];
void *bike[2];
void *pump;
void initveh();
~vbitmaps()
{
	free(car[0]);
	free(car[1]);
	free(car[2]);
	free(jeep[0]);
	free(jeep[1]);
	free(jeep[2]);
	free(bike[0]);
	free(bike[1]);
	free(pump);
}
};


void vbitmaps::initveh()
{
	drawbmp("pb_cars.bmp",0,0);

	car[0]=malloc(imagesize(22,15,130,52));//car1
	car[1]=malloc(imagesize(25,60,130,97));//car 2
	car[2]=malloc(imagesize(22,108,125,142));//car 3
	getimage(22,15,130,52,car[0]);
	getimage(25,60,130,97,car[1]);
	getimage(22,108,125,142,car[2]);

	jeep[0]=malloc(imagesize(175,12,272,52));    //jeep1
	jeep[1]=malloc(imagesize(170,55,272,105));    //jeep2
	jeep[2]=malloc(imagesize(168,120,272,170));    //jeep3
	getimage(175,12,272,52,jeep[0]);
	getimage(170,55,272,105,jeep[1]);
	getimage(168,120,272,170,jeep[2]);

	bike[0]=malloc(imagesize(338,16,418,77));    //bike one
	bike[1]=malloc(imagesize(335,88,422,155));    //bike two
	getimage(338,16,418,77,bike[0]);
	getimage(335,88,422,155,bike[1]);

	pump=malloc(imagesize(482,15,512,75));//petrol pump
	getimage(482,15,512,75,pump);
}

void drawbmp(char *filename,int xpos,int ypos)        //code to read a 256color bmp file
{
	FILE * file;
	int x,y,trash;
	char color;
	char palette[768];
	void * palptr;
	void *t=&trash;
	void * colorlocation=&color;
	file=fopen(filename,"rb");
	fseek(file,54,SEEK_SET);
	for (x=0;x<256;x++)
	{

		palptr=&palette[x*3+2];
		fread(palptr,1,1,file);

		palptr=&palette[x*3+1];
		fread(palptr,1,1,file);

		palptr=&palette[x*3];
		fread(palptr,1,1,file);

		fread(t,1,1,file);
	}
	int i;
	   //convert eight bits to six bits
	for(i=0;i<768;++i) palette[i]=palette[i] >> 2;

	REGS reg;
	SREGS sreg;
	reg.x.ax=0x1012;
	reg.x.bx=0;
	reg.x.cx=256;
	reg.x.dx=FP_OFF(palette);
	sreg.es=FP_SEG(palette);
	int86x(0x10,&reg,&reg,&sreg);
	for (y=0+ypos;y<480+ypos;y++)
	{
		for (x=0+xpos;x<640+xpos;x++)
		{
			fread(colorlocation,1,1,file);
			putpixel(x+xpos,479-y+(ypos*2),color);
		}
	}
	fclose(file);
	return;
}
